<?php
/****************************************************************

gmail-mobile (a.k.a. unofficial Gmail Mobile)
Copyright (c) 2005, 2006
Neerav Modi and others

Version 0.11 (c) 2004
GAN Ying Hung, Rudi Pittman, Gaston Annebicque

Licensed under the GNU GPL. For full terms see the file COPYING.

gmail-mobile (unofficial Gmail Mobile since Sept 2004) provides
access to Gmail accounts with any WAP enabled phone or hand held
(in WML format).

http://gmail-mobile.sourceforge.net

*****************************************************************/
   
////////////////////
//
// Config options start HERE
//


// Proxy
//
// Some servers go through a proxy server
// Proxy server settings may be set here
//
// The default is: all blank for NO PROXY
// $conf_proxy_server 	= "";	// proxy server
// $conf_proxy_user 	= "";	// proxy user
// $conf_proxy_passwd	= "";	// proxy passwords

$conf_proxy_server 	= "";	// proxy server
$conf_proxy_user 	= "";	// proxy user
$conf_proxy_passwd	= "";	// proxy passwords



// Use PIN code for easy signin
//
// If you are the only user of a PRIVATE and HIDDEN Gmail 
// installation, you can use a PIN code system for quick 
// and easy signin.
//
// The default is false.
//
// Uncomment ONE of the following (remove/add "//" at the
// beginning of the line)

$conf_use_pin = false;		// Do NOT use a PIN code signin
//$conf_use_pin = true;		// USE a PIN code signin


// Default time zone
//
// If you are the only user of this Gmail installation or
// all users are in the same time zone, setting this option
// will be a convenience when logging in.
//
// This setting can be overridden by a value added to the
// url of a bookmark.  See the README for more information.
//
// Time zones are like: -8, +3, +5.5, etc.
// The "+" or "-" is REQUIRED.  Use "0" for UTC(GMT)
// e.g.
// $conf_time_zone = "+5.5";	
//
// The default is "0"

$conf_time_zone = "0";	
							


// Messages on Sign in page
//
// On the signin page, there is a message at the bottom
// that mentions where to get more help if there are problems.
// If this installation is going to be used by more than 
// just you, and you would like to be the contact, you can 
// customize this.  You may also use this to display any information
// like a message-of-the-day or anything else.
//
// The default is "<small>Problem using gmail-mobile? Visit http://gmail-mobile.sourceforge.net</small>"
//
// Use of " needs to be escaped as \"  e.g. <a href=\"http://url.com\">
//
//     Character	
//     to display   Enter as
//     ---------    --------
//         "          &quote;
//         &          &amp;
//         \          \\
//         >          &gt;
//         <          &lt;
//         '          &#39;

$signin_message_bottom = "<small>Problem using gmail-mobile? Visit http://gmail-mobile.sourceforge.net</small>";	

// You may also add/customize a message to appear before "username".
// The can be used to display important announcements, etc.

$signin_message_top = "";	




// Enable attachment uploads
//
// This option turns off/on the ability to upload/attach files
// while composing a message.  If this is on, it will only work
// on mobiles that support file uploads.
//
// NOTE: This option uses double server bandwidth.
// Once for uploading the file from you mobile to the server, and once
// for the server to send the file to Gmail.  If you are very
// concerned about your bandwidth, or get close to your bandwidth 
// limit, you can turn this option OFF (false) or limiting the upload
// size in the next option.
// The default is true
//
// Uncomment ONE of the following (remove/add "//" at the
// beginning of the line)

$conf_enable_up_attach = true;		/* Enable file upload/attach */
//$conf_enable_up_attach = false;	/* Disable file upload/attach */



// Number of attachments allowed for uploading
// 
// If you have ENABLED attachment uploads, you may also control
// the number of attachments allowed.
//
// The default is 3
//
// Minimum is 0
// Maximum is 10
//
// e.g.
// $conf_up_attach_num_limit = 3;
//

$conf_up_attach_num_limit = 3;		/* maximum attachments allowed for upload */



// Maximum size of attachments allowed for uploading
// 
// If you have ENABLED attachment uploads, you may also control
// the maximum attachment size allowed here.  IN KILOBYTES
//
// Set this to 0 for UNLIMITED size (no limit).
// e.g.
// $conf_up_attach_size_limit = 0;
//
// The default is 0 (no limit)
//
// e.g.
// $conf_up_attach_size_limit = 200;
//

$conf_up_attach_size_limit = 0;		/* maximum attach size for upload in Kilobytes */



// Links: bottom of page, shortcut menu, or both
//
// gmail-mobile has a very helpful shortcut menu available
// on almost every page.  This includes quick links to major
// functions: summary, compose, contacts, settings, signout etc.
// The menu is available through a means specific to your phone
// model: soft-key, options -> shortcuts, etc.

// However, not all phones support this menu or it may be too 
// difficult to use on some unfriendly-designed devices.  The 
// menu also takes up some bandwidth and phone memory.  If you
// do not use the menu at all, or are very bandwidth conscious,
// you may turn off the menu and save upto 700-900 bytes per 
// page (status messages do not contain a menu anyway).
//
// These links are also available on the Summary page, and
// many places some links are displayed at the bottom of 
// the page.
//
// This setting allow you to choose which set of links should
// be shown. 
// 
// Bottom of page is 1
// Menu is 2
// Bottom and menu is 3 (1+2)
//
// The default is 3  (bottom links + menu)

// Uncomment ONE of the following (remove/add "//" at the
// beginning of the line)

//$conf_links_display = 1;		// Links at bottom of page ONLY
//$conf_links_display = 2;		// Links in menu ONLY
$conf_links_display = 3;		// Links BOTH on page AND in menu



// Message length (in characters) that should be displayed
// before breaking it into parts.  This length should be small
// (<2000) to ensure compatibilty with the oldest phones
// (and even newer phones like the Nokia 35xx).  If this is a 
// private installation, this length can be as large as your
// phone can handle.
//
// Minimum is 1000
// Maximum is 50000
//
// e.g.
// $conf_display_msg_length = 2000;
// $conf_display_msg_length = 10000;
//
// The default is 2500

$conf_display_msg_length = 2500;



// Maximum number of messages to list at one time when 
// viewing a mailbox.  If there are more messages than this,
// a "next" link will display
//
// Minimum is 1
// Maximum is 50
//
// e.g.
// $conf_num_msgs = 5;
//
// The default is 10

$conf_num_msgs = 10;	



// How to display the number of conversations for a mailbox
// (summary) listing
//
// On the Summary page, Gmail normally only displays the number
// of UNREAD (new) conversations in a standard mailbox or label.
// You can mimic the behavior of Yahoo or Hotmail or other
// email providers by also displaying the total number of 
// conversations
//
// Uncomment ONE of the following pairs of lines (remove/add "//" at the
// beginning of the line)
//
// FOR LABELS:  The default is false

$conf_disp_total_msgs = false;		/* Display Labels as (3) */
//$conf_disp_total_msgs = true;		/* Display Labels as (3/126) */

// FOR STANDARD BOXES:  The default is false
// A feature making it's WORLD's DEBUT in gmail-mobile!!
// WARNING:  Setting the STANDARD BOXES to TRUE will cause an extra 
// SEVEN (7) connections from your server to Gmail EVERY TIME THE SUMMARY
// DISPLAYS and thus the extra overhead in TRAFFIC EQUIVALENT TO VIEWING
// EACH STANDARD MAILBOX (all 25, 50, or 100 messages which would be 
// displayed by Gmail.
//
// The default is FALSE
//
// Uncomment ONE of the following (remove/add "//" at the
// beginning of the line)

$conf_disp_total_standard = false;		/* Display Standard boxes as (3) */
//$conf_disp_total_standard = true;		/* Display Standard boxes as (3/126) */



// How to display unread or new messages in a mailbox listing
//      asterik ... *Subject
//      bold ... Subject   (but will appear as bold)
//
// The default is false
//
// Uncomment ONE of the following (remove/add "//" at the
// beginning of the line)

$conf_unread_bold = false;	/* mark unread with asterik (*)  */
//$conf_unread_bold = true;	/* mark unread using BOLD */



// Allow attachment downloads?
// 
// Viewing/downloading an email attachment can be silly
// especially trying to view a high resolution picture (1024x786)
// on a tiny cell phone screen.  It also uses double server bandwidth.
// Once for the server to retrieve the attachment from Gmail, and once
// for your mobile to retrieve it from your server.  If you are very
// concerned about your bandwidth, or get close to your bandwidth 
// limit, you can turn one or more of the following 
// options OFF (false). 
// 
// You may also control the maximum attachment size in the next
// configuration option
//
// The default is true
//
// Uncomment ONE of EACH of the following pairs of lines 
// (remove/add "//" at the beginning of the line)

$conf_view_attach_image = true;		/* allow /dl image attach */
//$conf_view_attach_image = false;	/* disallow view/dl image attach */

$conf_view_attach_audio = true;		/* allow dl audio attach */
//$conf_view_attach_audio = false;	/* disallow dl audio attach */

$conf_view_attach_html = true;		/* allow view html attach */
//$conf_view_attach_html = false;	/* disallow view html attach */

$conf_view_attach_video = true;		/* allow view video attach */
//$conf_view_attach_html = false;	/* disallow view video attach */

$conf_view_attach_zip = true;		/* allow dl zip/jar/java attach */
//$conf_view_attach_zip = false;	/* disallow dl zip/jar/java attach */

$conf_view_attach_other = true;		/* allow dl other attach */
//$conf_view_attach_other = false;	/* disallow dl other attach */



// Maximum size of attachments allowed for downloading
// 
// If any of the previous options regarding attachments are TRUE,
// you may also control the maximum attachment size allowed.
//
// Set this to 0 for UNLIMITED size (no limit).
// e.g.
// $conf_dl_attach_size_limit = 0;
//
// The default is 0 (no limit)
//
// e.g.
// $conf_dl_attach_size_limit = 300;
//

$conf_dl_attach_size_limit = 0;		/* maximum attach size for downloads in Kilobytes */





////////////////////
//
// DO NOT EDIT ANYTHING BELOW
//

require_once("gmobile_env.php");

//
////////////////////

?>