<?
/****************************************************************

gmail-mobile (a.k.a. unofficial Gmail Mobile)
Copyright (c) 2005, 2006
Neerav Modi and others

Version 0.11 (c) 2004
GAN Ying Hung, Rudi Pittman, Gaston Annebicque

Licensed under the GNU GPL. For full terms see the file COPYING.

gmail-mobile (unofficial Gmail Mobile since Sept 2004) provides
access to Gmail accounts with any WAP enabled phone or hand held
(in WML format).

http://gmail-mobile.sourceforge.net

*****************************************************************/

require_once("libgmailer.php");
require_once("config.php");

// create the gmail object
$gmailer = new GMailer();
// initialize connection
quick_init($gmailer);

// Connect to gmail
connect_gmail();

// Localization (l10n) phrases
load_language();
																																						 
$status = false;
$status_message = "";

$action		= (isset($_REQUEST['act'])) 	? $_REQUEST['act']		: false;
$filter_id	= (isset($_POST['id'])) 		? $_POST['id']			: "";
$display 	= 10;	// display x filters per page

if (isset($_REQUEST['p'])) {
	$_SESSION['gm_filter_page'] = $_REQUEST['p'];
}
if (!isset($_SESSION['gm_filter_page'])) $_SESSION['gm_filter_page'] = 0;
$page = $_SESSION['gm_filter_page'];


if (!isset($_SESSION['gm_filter_list'])) {
	$gmailer->fetchBox(GM_PREFERENCE, 0, 0);
	$snapshot = $gmailer->getSnapshot(GM_PREFERENCE);
	if ($snapshot->created == 0) static_error($snapshot->snapshot_error);
	$_SESSION['gm_filter_list'] = $snapshot->filter;
}

// debug
//debug_print(print_r($_SESSION['gm_filter_list'],true));

//
// create the filter
//

if ($action == "create") {
	$_SESSION['gm_f_id']			= 0;  // filter id 0 for create
	$_SESSION['gm_f_from'] 			= "";
	$_SESSION['gm_f_to'] 			= "";
	$_SESSION['gm_f_subject']		= "";
	$_SESSION['gm_f_has']			= "";
	$_SESSION['gm_f_hasnot']		= "";
	$_SESSION['gm_f_hasAttach']		= 0;
	
	$_SESSION['gm_f_archive'] 		= 0;
	$_SESSION['gm_f_star'] 			= 0;
	$_SESSION['gm_f_label']			= 0;
	$_SESSION['gm_f_forward']		= 0;
	$_SESSION['gm_f_trash']			= 0;
	$_SESSION['gm_f_label_name']	= -1;  // actually a temporary number
	$_SESSION['gm_f_forwardto']		= "";
	// display filter screen
	print_filter_criteria();
	exit;

} elseif ($action == "criteria") {
	
	$_SESSION['gm_f_archive'] 	= (isset($_POST['archive']) and $_POST['archive'] != "")	? $_POST['archive'] : 0 ;
	$_SESSION['gm_f_star'] 		= (isset($_POST['star']) 	and $_POST['star'] != "") 		? $_POST['star'] 	: 0 ;
	$_SESSION['gm_f_label'] 	= (isset($_POST['label']) 	and $_POST['label'] != "") 		? $_POST['label'] 	: 0 ;
	$_SESSION['gm_f_forward']	= (isset($_POST['forward']) and $_POST['forward'] != "")	? $_POST['forward'] : 0 ;
	$_SESSION['gm_f_trash'] 	= (isset($_POST['trash']) 	and $_POST['trash'] != "") 		? $_POST['trash'] 	: 0 ;
	$_SESSION['gm_f_label_name']= (isset($_POST['label_name'])) ? $_POST['label_name'] 	: -1 ; // actually a temporary number
	$_SESSION['gm_f_forwardto'] = stripslashes(trim((isset($_POST['forwardto'])) 		? $_POST['forwardto'] 	: ""));

	// display filter screen
	print_filter_criteria();
	exit;

} elseif ($action == "test" or $action == "action") {
	$_SESSION['gm_f_from'] 		= stripslashes(trim((isset($_POST['from'])) 	? $_POST['from'] 	: ""));
	$_SESSION['gm_f_to'] 		= stripslashes(trim((isset($_POST['to'])) 		? $_POST['to'] 		: ""));
	$_SESSION['gm_f_subject'] 	= stripslashes(trim((isset($_POST['subject'])) 	? $_POST['subject'] : ""));
	$_SESSION['gm_f_has'] 		= stripslashes(trim((isset($_POST['has'])) 		? $_POST['has'] 	: ""));
	$_SESSION['gm_f_hasnot'] 	= stripslashes(trim((isset($_POST['hasnot'])) 	? $_POST['hasnot'] 	: ""));
	$_SESSION['gm_f_hasAttach']	= (isset($_POST['hasAttach']) and $_POST['hasAttach'] != "")	? $_POST['hasAttach'] : 0 ;
	
	// display filter screen
	if ($action == "test") {
		print_filter_criteria();
	} elseif ($action == "action") {
		print_filter_action();
	}
	exit;

} elseif ($action == "save") {
	$archive 	= (isset($_POST['archive'])	and $_POST['archive']!= "")	? $_POST['archive'] : 0 ;
	$star 		= (isset($_POST['star'])	and $_POST['star']!= "") 	? $_POST['star'] 	: 0 ;
	$label 		= (isset($_POST['label'])	and $_POST['label']!= "") 	? $_POST['label'] 	: 0 ;
	$forward 	= (isset($_POST['forward'])	and $_POST['forward']!= "")	? $_POST['forward'] : 0 ;
	$trash 		= (isset($_POST['trash'])	and $_POST['trash']!= "") 	? $_POST['trash'] 	: 0 ;
	$label_name = (isset($_POST['label_name'])) ? $_POST['label_name'] : -1 ;	// actually a temporary number
	$forwardto 	= stripslashes(trim((isset($_POST['forwardto'])) 	? $_POST['forwardto'] 	: ""));

	// converts numeric label into text AND url encodes it
	//$label_name = ($label_name >=0) ? addslashes(urlencode($_SESSION['gm_all_labels'][(int)$label_name])) : "";
	$label_name = ($label_name >=0) ? $_SESSION['gm_all_labels'][(int)$label_name] : "";

	// perform the action
	$status = $gmailer->editFilter(
		$_SESSION['gm_f_id'],  // filter id (0 for create, number for edit
		$_SESSION['gm_f_from'], $_SESSION['gm_f_to'], $_SESSION['gm_f_subject'],
		$_SESSION['gm_f_has'], $_SESSION['gm_f_hasnot'], $_SESSION['gm_f_hasAttach'],
		$archive, $star, $label, $label_name, $forward, $forwardto, $trash
	);
	$status_message	= $gmailer->lastActionStatus('message');

	// updates cached filters
	// and cached labels
	if ($status) {
		$snapshot = $gmailer->getSnapshot(GM_PREFERENCE);
		if ($snapshot->created == 0) static_error($snapshot->snapshot_error);
		$_SESSION['gm_filter_list'] = $snapshot->filter;
		$_SESSION['gm_all_labels'] = $snapshot->label_list;
	}

} elseif ($action == "edit") {
	$ids 	= explode(";",$_REQUEST['f_ids']);
	$values = explode(";",str_replace(")","",$_REQUEST['f_vals']));
	$temp_label = "";
	
	$edit_id = "";
	$count_ids = count($ids);
	for ($i=0 ; $i < $count_ids; $i++) {
		if ($values[$i] == "e") {
			$edit_id = $ids[$i];
			break;
		}
	}

	if ($edit_id != "") {
		$count_filters = count($_SESSION['gm_filter_list']);
		for ($i = 0 ; $i < $count_filters; $i++) {
			if ($_SESSION['gm_filter_list'][$i]['id'] != $edit_id) continue;
	
			$_SESSION['gm_f_id']			= $edit_id;
			$_SESSION['gm_f_from'] 			= $_SESSION['gm_filter_list'][$i]['from'];
			$_SESSION['gm_f_to'] 			= $_SESSION['gm_filter_list'][$i]['to'];
			$_SESSION['gm_f_subject']		= $_SESSION['gm_filter_list'][$i]['subject'];
			$_SESSION['gm_f_has']			= $_SESSION['gm_filter_list'][$i]['has'];
			$_SESSION['gm_f_hasnot']		= $_SESSION['gm_filter_list'][$i]['hasnot'];
			$_SESSION['gm_f_hasAttach']	= (isset($_SESSION['gm_filter_list'][$i]['hasAttach']))
				? $_SESSION['gm_filter_list'][$i]['hasAttach']
				: 0
				;
			
			$_SESSION['gm_f_archive'] 		= $_SESSION['gm_filter_list'][$i]['archive'];
			$_SESSION['gm_f_star'] 			= $_SESSION['gm_filter_list'][$i]['star'];
			$_SESSION['gm_f_label']			= $_SESSION['gm_filter_list'][$i]['label'];
			$_SESSION['gm_f_forward']		= $_SESSION['gm_filter_list'][$i]['forward'];
			$_SESSION['gm_f_trash']			= $_SESSION['gm_filter_list'][$i]['trash'];
			$temp_label						= $_SESSION['gm_filter_list'][$i]['label_name'];
			$_SESSION['gm_f_forwardto']		= $_SESSION['gm_filter_list'][$i]['forwardto'];
			break;
		}
		// convert text label into numeric index
		$_SESSION['gm_f_label_name'] = -1;				// actually a temporary number
		if ($temp_label != "") {
			reset($_SESSION['gm_all_labels']);
			foreach ($_SESSION['gm_all_labels'] as $indexval => $lbl) {
				if ($lbl === $temp_label) {
					$_SESSION['gm_f_label_name'] = $indexval;	// actually a temporary number
					break;
				}
			}
		}
		// display filter screen
		print_filter_criteria();
		exit;
	}
	
	$status_message = $gm_lang['no_filter_edit'];


} elseif ($action == "delete") {

	$ids 	= explode(";",$_REQUEST['f_ids']);
	$values = explode(";",str_replace(")","",$_REQUEST['f_vals']));

	$delete_id = "";
	$count_ids = count($ids);
	for ($i=0 ; $i < $count_ids; $i++) {
		if ($values[$i] == "d") {
			$delete_id = $ids[$i];
			break;
		}
	}

	$status			= $gmailer->deleteFilter($delete_id);
	$status_message	= $gmailer->lastActionStatus('message');

	if ($status) {
		$snapshot = $gmailer->getSnapshot(GM_PREFERENCE);
		if ($snapshot->created == 0) static_error($snapshot->snapshot_error);
		// updates cached filters
		$_SESSION['gm_filter_list'] = $snapshot->filter;
	}
}

// for debugging
/* print_r($gmailer); */
/* print_r($snapshot); */
//debug_print(print_r($snapshot,true));
/* exit; */

$f_count = count($_SESSION['gm_filter_list']);
$has_filters = ($f_count > 0) ? true : false ;
$pages = ceil($f_count / $display);
if ($filter_id != "") {
	// determines which page to return to
	for ($i=0 ; $i < $f_count ; $i++) {
		if ($_SESSION['gm_filter_list'][$i]['id'] == "$filter_id") {
			$page = floor($i / $display);
			break;
		}
	}
} elseif ($action == "save") {
	$page = floor($f_count / $display);
}
$start = $page*$display;

$ids = "-1";
$values = "-1";
$set_vars = "";
for ($i = $start ; $i < $start+$display and $i < $f_count; $i++) {
	$id	= $_SESSION['gm_filter_list'][$i]['id'];
	$set_vars .= "<setvar name=\"f_$id\" value=\"0\" />\n";
	$ids .= ";".$id;
	$values .= ";"."$(f_".$id.")";
}

//
// Display Filter page
//

print_headers();	// send wml headers
?>
<template>
<do type="prev" label="Back" name="z"><prev/></do>
</template>
<card title="<? echo $gm_lang['filters'] ?>" id="main">
<onevent type="onenterforward">
<refresh>
<setvar name="p" value="<? echo $page ?>" />
<? echo $set_vars ; ?>
</refresh>
</onevent>
<p>
<?
// display a system-wide message
system_message();	

if ($status_message != "") echo "<em>".str_replace($gm_lang['learn_more'],"",sanitize_body($status_message))."</em><br /><br />\n";
?>
<b><? echo $gm_lang['filters'] ?></b><br />
<br />
<small><b><? echo $gm_lang['fol_filters_applied']?></b></small><br />
<br />
<?
if ($has_filters) {
	for ($i = $start ; $i < $start+$display and $i < $f_count; $i++) {
		$id			= $_SESSION['gm_filter_list'][$i]['id'];
		$query 		= $_SESSION['gm_filter_list'][$i]['query'];
		$star		= $_SESSION['gm_filter_list'][$i]['star'];
		$archive	= $_SESSION['gm_filter_list'][$i]['archive'];
		$trash		= $_SESSION['gm_filter_list'][$i]['trash'];
		$label		= $_SESSION['gm_filter_list'][$i]['label'];
		$labelas	= $_SESSION['gm_filter_list'][$i]['label_name'];
		$forward	= $_SESSION['gm_filter_list'][$i]['forward'];
		$forward_to	= $_SESSION['gm_filter_list'][$i]['forwardto'];
	
		$do_this = "";
		if ($forward) 	$do_this .= ($do_this == "") ? $gm_lang['forward_to']." $forward_to" : ", ".$gm_lang['forward_to']." $forward_to";
		if ($archive or $trash)
					 	$do_this .= ($do_this == "") ? $gm_lang['skip_inbox'] : ", ".$gm_lang['skip_inbox'];
		if ($trash) 	$do_this .= ($do_this == "") ? $gm_lang['move_to_trash_low'] : ", ".$gm_lang['move_to_trash_low'];
		if ($star) 		$do_this .= ($do_this == "") ? $gm_lang['star_it'] : ", ".$gm_lang['star_it'];
 		if ($label)		$do_this .= ($do_this == "") ? $gm_lang['apply_label_low']." \"$labelas\"" : ", ".$gm_lang['apply_label_low']." \"$labelas\"";

		echo "<small>";
		echo $gm_lang['matches']." <b>".cleanse_string($query)."</b><br />\n";
		echo $gm_lang['do_this']." ".cleanse_string($do_this)."<br />\n";
		echo "</small>";
	
		echo "<select name=\"f_$id\">\n";
		echo "<option value=\"0\"> - </option>\n";
		echo "<option value=\"e\">".$gm_lang['edit']."</option>\n";
		echo "<option value=\"d\">".$gm_lang['delete']."</option>\n";
		echo "</select>\n";
		echo "<br />\n";
	}
	
	if ($pages > 1 or $page >= $pages) page_nav();
} else {
	echo $gm_lang['have_no_filters']."<br />\n";
}
echo "<br />\n";
print_filter_footer();
print_footer();


function print_filter_footer() {
	global $page;
	global $ids;
	global $values;
	global $has_filters;
	global $gm_lang;
	
	echo "<a href='".basename(SELF)."?act=create".RANDOM.GMID."'>".$gm_lang['create_new_filter']."</a><br />\n";
	if ($has_filters) { 
	?>
	<anchor title="<? echo $gm_lang['edit_filter'] ?>"><go href="<? echo basename(SELF).'?act=edit&amp;p='.$page.'&amp;'.strip_tags(SID) ?>" method="post">
		<?
		echo "<postfield name=\"f_ids\" value=\"".$ids."\" />\n";
		echo "<postfield name=\"f_vals\" value=\"".$values."\" />\n";
		?>
	</go><? echo $gm_lang['edit_filter'] ?></anchor>
	<br />
	<anchor title="<? echo $gm_lang['delete_filter'] ?>"><go href="<? echo basename(SELF).'?act=delete&amp;p='.$page.'&amp;'.strip_tags(SID) ?>" method="post">
		<?
		echo "<postfield name=\"f_ids\" value=\"".$ids."\" />\n";
		echo "<postfield name=\"f_vals\" value=\"".$values."\" />\n";
		?>
	</go><? echo $gm_lang['delete_filter'] ?></anchor>
	<br />
	<?

	}
	
	echo "----------<br />";

	echo "<a href='setting.php?".RANDOM.GMID."'>".$gm_lang['settings']."</a><br />\n";
	echo "<a href='main.php?sum=1".RANDOM.GMID."'>".$gm_lang['summary']."</a><br />\n";
	echo "<a href='compose.php?action=new&amp;back=filter.php".RANDOM.GMID."'>".$gm_lang['compose_mail']."</a><br />\n";
	echo "<a href='logout.php?".RANDOM.GMID."'>".$gm_lang['sign_out']."</a>\n";
	echo "</p>\n";
}

function page_nav() {
	global $pages;
	global $view;
	global $page;
	global $gm_lang;
	
	$page_display = $page+1;
	echo sprintf($gm_lang['page_x_go_to_y'],$page_display)." \n";
	echo "<select name=\"p\">\n";
	for ($i=0; $i < $pages ; $i++) {
		$page_num = $i + 1;
		echo "<option value=\"$i\">$page_num</option>\n";
	}
	echo "</select>\n";
	?>

	<anchor title="<? echo $gm_lang['go_to_page'] ?>"><go href="<? echo basename(SELF).'?'.strip_tags(SID) ?>" method="post">
		<postfield name="p" value="$(p)" />
	</go><? echo $gm_lang['go'] ?></anchor>
	<br />
	<br />
	<?
}

function print_filter_criteria() {
	global $action;
	global $gmailer;
	global $conf;
	global $gm_lang;
	
	print_headers();	// send wml headers
	?>
<template>
<do type="prev" label="<? echo $gm_lang['back'] ?>" name="z"><prev/></do>
</template>
<card title="<? echo $gm_lang['filter'] ?>" id='main'>
<onevent type="onenterforward">
<refresh>
<setvar name="from" value="<? echo cleanse_string($_SESSION['gm_f_from']) ?>" />
<setvar name="to" value="<? echo cleanse_string($_SESSION['gm_f_to']) ?>" />
<setvar name="subject" value="<? echo cleanse_string($_SESSION['gm_f_subject']) ?>" />
<setvar name="has" value="<? echo cleanse_string($_SESSION['gm_f_has']) ?>" />
<setvar name="hasnot" value="<? echo cleanse_string($_SESSION['gm_f_hasnot']) ?>" />
<setvar name="hasAttach" value="<? echo cleanse_string($_SESSION['gm_f_hasAttach']) ?>" />
</refresh>
</onevent>
<p>
<?
// display a system-wide message
system_message();	

?><b><? echo ($_SESSION['gm_f_id'] == 0) ? $gm_lang['create_a_filter'] : $gm_lang['edit_a_filter']; ?><br />
<br />
<small><? echo $gm_lang['choose_search_crit'] ?></small></b><br />
<br />
<? echo $gm_lang['from'] ?><br />
<input title="<? echo $gm_lang['from'] ?>" name="from" format="*m" emptyok="true" /><br />
<? echo $gm_lang['to'] ?><br />
<input title="<? echo $gm_lang['to'] ?>" name="to" format="*m" emptyok="true" /><br />
<? echo $gm_lang['subject'] ?><br />
<input title="<? echo $gm_lang['subject'] ?>" name="subject" format="*m" emptyok="true" /><br />
<? echo $gm_lang['has_the_words'] ?><br />
<input title="<? echo $gm_lang['has_the_words'] ?>" name="has" format="*m" emptyok="true" /><br />
<? echo $gm_lang['doesnt_have'] ?><br />
<input title="<? echo $gm_lang['doesnt_have'] ?>" name="hasnot" format="*m" emptyok="true" /><br />
<? echo $gm_lang['has_attachment_cap'] ?><br />
<select title="<? echo $gm_lang['has_attachment_col'] ?>" name="hasAttach">
	<option value="0"> - </option>
	<option value="1"><? echo $gm_lang['yes'] ?></option>
</select>
<br />
<br />
<a href="<? echo basename(SELF) ?>?p=0<? echo RANDOM.GMID ?>"><? echo $gm_lang['cancel'] ?></a><br />
<anchor title="<? echo $gm_lang['test_search'] ?>"><go href="<? echo basename(SELF).'?act=test&amp;'.strip_tags(SID) ?>" method="post">
	<?
	echo "<postfield name=\"from\" value=\"$(from)\" />\n";
	echo "<postfield name=\"to\" value=\"$(to)\" />\n";
	echo "<postfield name=\"subject\" value=\"$(subject)\" />\n";
	echo "<postfield name=\"has\" value=\"$(has)\" />\n";
	echo "<postfield name=\"hasnot\" value=\"$(hasnot)\" />\n";
	echo "<postfield name=\"hasAttach\" value=\"$(hasAttach)\" />\n";
	?>
</go><? echo $gm_lang['test_search'] ?></anchor>
<br />
<b><anchor title="<? echo $gm_lang['next_step'] ?> &gt;&gt;"><go href="<? echo basename(SELF).'?act=action&amp;'.strip_tags(SID) ?>" method="post">
	<?
	echo "<postfield name=\"from\" value=\"$(from)\" />\n";
	echo "<postfield name=\"to\" value=\"$(to)\" />\n";
	echo "<postfield name=\"subject\" value=\"$(subject)\" />\n";
	echo "<postfield name=\"has\" value=\"$(has)\" />\n";
	echo "<postfield name=\"hasnot\" value=\"$(hasnot)\" />\n";
	echo "<postfield name=\"hasAttach\" value=\"$(hasAttach)\" />\n";
	?>
</go><? echo $gm_lang['next_step'] ?> &gt;&gt;</anchor></b>
<br />
<br />
<? 
	// construct the query
	$test_query = "";
	if ($_SESSION['gm_f_has'] != "") 		$test_query .= $_SESSION['gm_f_has']. " ";
	if ($_SESSION['gm_f_hasnot'] != "") 	$test_query .= "-(".$_SESSION['gm_f_hasnot']. ") ";
	if ($_SESSION['gm_f_subject'] != "") 	$test_query .= "subject:(".$_SESSION['gm_f_subject'].") ";
	if ($_SESSION['gm_f_from'] != "") 		$test_query .= "from:(".$_SESSION['gm_f_from'].") ";
	if ($_SESSION['gm_f_to'] != "") 		$test_query .= "to:(".$_SESSION['gm_f_to'].") ";
	if ($_SESSION['gm_f_hasAttach']) 		$test_query .= "has:attachment ";
	$test_query = str_replace("  "," ",trim($test_query));	// cleanup

	if ($test_query != "") {
		// fetch query
		$test_query = "search=query&q=".urlencode($test_query)."&view=tl&start=0";
		$gmailer->fetch($test_query);
		$snapshot = $gmailer->getSnapshot(GM_QUERY);
		if ($snapshot->created == 0) static_error($snapshot->snapshot_error);
	
		$msgs_per_page = ($_SESSION['gm_msg_per_page'] < $conf['num_msgs']) 
			? $_SESSION['gm_msg_per_page'] 
			: floor($_SESSION['gm_msg_per_page']*(1/2))
			;
		
		// display query results
		echo $snapshot->box_name."<br /><br />\n";
		$count_convs = count($snapshot->box);
		for ($i = 0; $i < $count_convs && $i<$msgs_per_page; $i++) {
			// display "star.gif" if the msg is starred
			if ($snapshot->box[$i]['is_starred']) {
				echo "<img src='star.gif' alt='*' /> ";
			}
		
			// display "from"
			$sender = str_replace(array("<b>","</b>"),array("[[b]]","[[/b]]"), $snapshot->box[$i]['sender']);
			$sender = cleanse_string($sender);
			$sender = str_replace(array("[[b]]","[[/b]]"),array("<b>","</b>"), $sender);
			echo "$sender<br />\n";
			
			// display labels
			$all_msg_labels = "";
			foreach ($snapshot->box[$i]['labels'] as $label_entry) {
				switch ($label_entry) {
					case "^i": 	$label_entry_name = $gm_lang['std_box_name'][0]; break;
					case "^s": 	$label_entry_name = $gm_lang['std_box_name'][5]; break;
					case "^k": 	$label_entry_name = $gm_lang['std_box_name'][6]; break;
					case "^r": 	$label_entry_name = $gm_lang['std_box_name'][3]; break;
					default:	$label_entry_name = $label_entry; 				 break;
				}
				$all_msg_labels .= ($all_msg_labels != "") ? ", ".$label_entry_name : $label_entry_name ;
			}
			if ($all_msg_labels != "") echo "<small>".cleanse_string($all_msg_labels)."</small><br />\n";
			
			// display "to" flag
			$flag = false;
			if ($snapshot->box[$i]['flag'] == "<b>&rsaquo;</b>&nbsp;") {
				echo "&gt;&nbsp;";
				$flag = true;
			} elseif ($snapshot->box[$i]['flag'] == "<b>&raquo;</b>&nbsp;") {
				echo "&gt;&gt;&nbsp;";
				$flag = true;
			}
		
			// Subject: remove the <b> that gmail put on new mail
			$subject = str_replace(array("<b>","</b>"),"", $snapshot->box[$i]['subj']);
			$subject = html_entity_decode($subject);
			$subject = str_replace(array("$"),array(""),$subject);
		
			// cut the subject down to something more manageable for mobiles
			if (strlen($subject) > 60) {
				$subject = substr($subject,0,60)."...";
			}
			$subject = cleanse_string($subject,true);
			
			// Subject: if the message is unread, display it so
			if ($snapshot->box[$i]['is_read'] == 1) {
				if ($conf['unread_bold']) {
					// display unread messages in bold
					echo "<b>$subject</b><br />\n";
				} else {
					// display unread messages with an asterix (*)
					echo "<b>*&nbsp;</b>$subject<br />\n";
				}
			} else {
				echo "$subject<br />\n";
			}
		
			// display date
			echo cleanse_string($snapshot->box[$i]['date'])."<br />\n";
			
		
			// display attachments if any
			if (count($snapshot->box[$i]['attachment']) > 0) {
				echo "<img src='clip.gif' alt='@' /><br />";
			}
		
			// need a break!
			echo "<br />\n";
		}
	} 
	echo "<br />\n";
	echo "</p>\n";
	print_footer();
}

function print_filter_action() {
	global $gm_lang;

	print_headers();	// send wml headers
	?>
<template>
<do type="prev" label="<? echo $gm_lang['back'] ?>" name="z"><prev/></do>
</template>
<card title='<? echo $gm_lang['filter'] ?>' id='main'>
<onevent type="onenterforward">
<refresh>
<setvar name="archive" value="<? echo $_SESSION['gm_f_archive'] ?>" />
<setvar name="star" value="<? echo $_SESSION['gm_f_star'] ?>" />
<setvar name="label" value="<? echo $_SESSION['gm_f_label'] ?>" />
<setvar name="forward" value="<? echo $_SESSION['gm_f_forward'] ?>" />
<setvar name="trash" value="<? echo $_SESSION['gm_f_trash'] ?>" />
<setvar name="label_name" value="<? echo $_SESSION['gm_f_label_name'] ?>" />
<setvar name="forwardto" value="<? echo $_SESSION['gm_f_forwardto'] ?>" />
</refresh>
</onevent>
<p>
<?
// display a system-wide message
system_message();	

?><b><? echo ($_SESSION['gm_f_id'] == 0) ? 'Create' : 'Edit'; ?> a Filter<br />
<br />
<small><? echo $gm_lang['choose_action'] ?></small></b><br />
<br />
<? echo $gm_lang['skip_the_inbox'] ?><br />
<small>(<? echo $gm_lang['archive_it'] ?>)</small><br />
<select title="<? echo $gm_lang['skip_the_inbox'] ?>" name="archive">
	<option value="0"> - </option>
	<option value="1"><? echo $gm_lang['yes'] ?></option>
</select><br />

<? echo $gm_lang['star_it'] ?><br />
<select title="Star it" name="star">
	<option value="0"> - </option>
	<option value="1"><? echo $gm_lang['yes'] ?></option>
</select><br />

<? echo $gm_lang['apply_the_label'] ?><br />
<select title="<? echo $gm_lang['apply_the_label'] ?>:" name="label">
	<option value="0"> - </option>
	<option value="1"><? echo $gm_lang['yes'] ?></option>
</select>
<select title="<? echo $gm_lang['label_col'] ?>" name="label_name">
	<option value="-1"> - </option>
	<?
	reset($_SESSION['gm_all_labels']);
	foreach ($_SESSION['gm_all_labels'] as $indexval => $lbl) {
		echo "<option value=\"$indexval\">".cleanse_string($lbl)."</option>\n";
	}
	?></select>
<br />

<? echo $gm_lang['forward_it'] ?><br />
<select title="<? echo $gm_lang['forward_it'] ?>" name="forward">
	<option value="0"> - </option>
	<option value="1"><? echo $gm_lang['yes'] ?></option>
</select><br />
<? echo $gm_lang['forward_to_col'] ?><br />
<input title="<? echo $gm_lang['forward_to_email'] ?>" name="forwardto" format="*m" emptyok="true" /><br />

<? echo $gm_lang['move_it_to_trash'] ?><br />
<select title="<? echo $gm_lang['move_it_to_trash'] ?>" name="trash">
	<option value="0"> - </option>
	<option value="1"><? echo $gm_lang['yes'] ?></option>
</select><br />
<br />
<a href="<? echo basename(SELF) ?>?p=0<? echo RANDOM.GMID ?>"><? echo $gm_lang['cancel'] ?></a><br />
<anchor title="&lt;&lt; <? echo $gm_lang['back'] ?>"><go href="<? echo basename(SELF).'?act=criteria&amp;'.strip_tags(SID) ?>" method="post">
	<?
	echo "<postfield name=\"archive\" value=\"$(archive)\" />\n";
	echo "<postfield name=\"star\" value=\"$(star)\" />\n";
	echo "<postfield name=\"label\" value=\"$(label)\" />\n";
	echo "<postfield name=\"forward\" value=\"$(forward)\" />\n";
	echo "<postfield name=\"trash\" value=\"$(trash)\" />\n";
	echo "<postfield name=\"label_name\" value=\"$(label_name)\" />\n";
	echo "<postfield name=\"forwardto\" value=\"$(forwardto)\" />\n";
	?>
</go>&lt;&lt; <? echo $gm_lang['back'] ?></anchor>
<br />
<b><anchor title="<? echo ($_SESSION['gm_f_id'] == 0) ? $gm_lang['create_filter'] : $gm_lang['update_filter']; ?>"><go href="<? echo basename(SELF).'?act=save&amp;'.strip_tags(SID) ?>" method="post">
	<?
	echo "<postfield name=\"archive\" value=\"$(archive)\" />\n";
	echo "<postfield name=\"star\" value=\"$(star)\" />\n";
	echo "<postfield name=\"label\" value=\"$(label)\" />\n";
	echo "<postfield name=\"forward\" value=\"$(forward)\" />\n";
	echo "<postfield name=\"trash\" value=\"$(trash)\" />\n";
	echo "<postfield name=\"label_name\" value=\"$(label_name)\" />\n";
	echo "<postfield name=\"forwardto\" value=\"$(forwardto)\" />\n";
	?>
</go><? echo ($_SESSION['gm_f_id'] == 0) ? $gm_lang['create_filter'] : $gm_lang['update_filter']; ?></anchor></b>
<br />
<br />
	<?
	echo "<br />\n";
	echo "</p>\n";
	print_footer();
}

?>