<?
/****************************************************************

gmail-mobile (a.k.a. unofficial Gmail Mobile)
Copyright (c) 2005, 2006
Neerav Modi and others

Version 0.11 (c) 2004
GAN Ying Hung, Rudi Pittman, Gaston Annebicque

Licensed under the GNU GPL. For full terms see the file COPYING.

gmail-mobile (unofficial Gmail Mobile since Sept 2004) provides
access to Gmail accounts with any WAP enabled phone or hand held
(in WML format).

http://gmail-mobile.sourceforge.net

*****************************************************************/

/////////////////////////
//
// Define functions and basic repetitive
// tasks of gmail-mobile
//
/////////////////////////

// !!!!!!!!!!!!!!!!!!!!!!
//
// DO NOT ALTER THIS FILE UNLESS YOU
// REALLY KNOW WHAT YOU ARE DOING!!
//
// Even then, there is no reason to edit
// this file ! ;-)
//
// !!!!!!!!!!!!!!!!!!!!!!

/////////////////////////
//
// Functions
//

function system_message() {
	return 1;
}

function connect_gmail() {
	global $gmailer;
	if (!$gmailer->connect()) { 
	
		// if not connected to gmail, return to login page with error

		if (!isset($_SESSION['id_key']) or ($_SESSION['id_key'] == "")) {
			// 17 session timeout(ik)
			$error = 17;
		} elseif (!isset($_SESSION['gm_welcome_msg'])) {
			// 16 session timeout (non-ik)
			$error = 16;
		} else {
			// 15 connection error
			$error = 15;
		}

		@session_unset();
		@session_destroy();	

		// Redirect
		header("Location: http://".HOST.DIR_PATH."/index.php?err=".$error);
		// MUST exit script after redirecting
		exit;
	}
	
	// SET GMID
	if (
		!(isset($_COOKIE[session_name()]) and $_COOKIE[session_name()] == session_id())
		 and ((bool)ini_get("session.use_trans_sid") === false)
		) {
		define('GMID', '&amp;'.strip_tags(SID));
	} else {
		define('GMID', "");
	}
}


function load_language() {
	global $gm_lang;
	// Localization (l10n) phrases
	if (	(isset($_SESSION['gm_language'])) 
		and ($_SESSION['gm_language'] != "en")
		and ($_SESSION['gm_language'] != "")
		) {
		if (file_exists("lang/".$_SESSION['gm_language'].".php")) {
			include("lang/".$_SESSION['gm_language'].".php");
		}
	}
}


function static_error($error_num) {
	global $gm_lang;
	
	if (substr($error_num,0,1) == 5) {
		$title = $gm_lang['5xx_server_error'];
		$header = $gm_lang['5xx_server_error'];
		switch($error_num) {
			case 500:
				$title = $gm_lang['500_server_error'];
				//debug_print("A 500 error was displayed.");
				$message = $gm_lang['500_error_msg'];
				break;
			case 502:
				$title = $gm_lang['502_server_error'];
				//debug_print("A 502 error was displayed.");
				$message = $gm_lang['502_error_msg'];
				break;
			default:
				//debug_print("A 5xx error was displayed.");
				$message = $gm_lang['5xx_error_msg'];
				break;
		}
	} elseif (substr($error_num,0,7) == "session") {
		$title = "Invalid";
		$header = "Invalid Bookmark";
		$gmobile_loc = "http://".HOST.((dirname(SELF) != "/")?dirname(SELF):"");
		$message = "<br />Only the gmail-mobile sign-in page should be bookmarked:<br />"
			.$gmobile_loc."<br /><br />"
			."To remember the username, bookmark as:<br />"
			.$gmobile_loc."/index.php?u=username<br /><br />"
			."To remember the timezone, bookmark as:<br />"
			.$gmobile_loc."/index.php?u=username&amp;tz=YourTimeZone<br /><br />"
			."For PIN sign-in, bookmark that page.<br /><br />"
			;
	} elseif (substr($error_num,0,4) == "libg") {
		$title = $gm_lang['libg_error_short'];
		$header = $gm_lang['libg_error'];
/* 		debug_print("A libgXXX error was displayed."); */
/* 		$message = $gm_lang['libg101_error']; */
		switch($error_num) {
			case "libg101":
				//debug_print("A libg101 error was displayed.");
				$message = $gm_lang['libg101_error_msg'];
				break;
			case "libg110":
				//debug_print("A libg110 error was displayed.");
				$url = "http://".HOST.DIR_PATH."/index.php?err=40";
				redirect_page($url, $gm_lang['gmail_error'], $gm_lang['libg110_error_msg'], 50);
				exit;	
				break;
			default:
				//debug_print("A libgXXX error was displayed.");
				$message = $gm_lang['libg_error_msg'];
				break;
		}
	} else {
		//debug_print("An error was displayed: ".$error_num);
		msg_not_found($gm_lang['unknown_error_msg'], "", $gm_lang['unknown_error']);
		
	}				

	print_headers();	// send wml headers
	
	//include("template.php");
?>
<card id="main" title="<? echo $title; ?>">
	<p>
	<b><? echo $header; ?></b><br /><br />
	<? echo $message; ?><br />
	</p>
	<?
	print_footer();
	// MUST exit script after displaying error
 	exit();
}

function msg_not_found($error_msg = "", $url = "", $title = "") {
	global $gm_lang;
	
	if ($error_msg == "") 	$error_msg = $gm_lang['message_not_found'];
	if ($title == "") 		$title = $gm_lang['not_found'];

	$_SESSION['gm_msg_cache_id']	= "";
	$_SESSION['gm_thread_cache_id']	= "";

	if ($url != "") {
		$message = $error_msg;
	} else {
		$backto = (isset($_SESSION['gm_backto'])) ? $_SESSION['gm_backto'] : "..." ;
		$message = $error_msg."<br /><br />".sprintf($gm_lang['returning_to'],$backto);
		$url = "main.php";
	}

	// actual redirection
	redirect_page($url, $title, $message, 80);	

	// MUST exit script after redirecting
 	exit();
}


// Returns a random string
function str_rand($length = 4) {
	$seeds = 'abcdefghijklmnopqrstuvwxyz0123456789';
    $str = '';
    $seeds_count = strlen($seeds);
 
    // Generate
    for ($i = 0; $length > $i; $i++) {
        $str .= $seeds{mt_rand(0, $seeds_count - 1)};
    }
 
    return $str;
}
 
function cleanse_string($string, $minimum = false) {

/* 	$string = stripslashes($string); */
	
	if ($minimum) {
		$string = htmlspecialchars($string);
	} else {
		$string = htmlspecialchars(html_entity_decode($string));
	}

	// WML encode $ signs
	$string = str_replace("$","$$",$string);
	
	return $string;
	
}

function un_htmlspecialchars ($string) {

	$encoded_html = array('&amp;','&gt;','&lt;','&#39;','&#34;','&quot;');
	$decoded_html = array("&",">","<","'",'"','"');

	$string = str_replace($encoded_html,$decoded_html,"$string");

	return $string;
}

function code_url ($url,$code) {

	$encoded_url = array("AMPER","EQUAL","QUEST","SLASH");
	$decoded_url = array('&amp;','=','?','/');

	if ($code == "encode") {
		$url = str_replace($decoded_url,$encoded_url,"$url");
	} elseif ($code == "decode") {
		$url = str_replace($encoded_url,$decoded_url,"$url");
	}

	return $url;
}

// quick initialization of gmailer
function quick_init(&$gmailer) {
	global $session_method;

	if ($gmailer->created) {
		if (strlen(P_PROXY) > 0)
			$gmailer->setProxy(P_PROXY, P_USER, P_PWD);
		if (isset($session_method))
			$gmailer->setSessionMethod($session_method);
	} else {
		die("failed to create gmailer object");
	}
	return 0;
}


// $delay in tenths of a second
function redirect_page($url, $title, $message, $delay = 5, $clear_history = false) {
	
	global $gm_lang;

	// anti-proxy measure -- create random string in url
	$pos = strpos($url,"=");
	if ($pos === false) {
		$url .= '?';
	} else {
		$url .= "&amp;";
	}
	$url .= "z=".str_rand(10);

	if ($clear_history) $url .= "&amp;clrh=1";
	
	if (basename(SELF) != "logout.php") {
		$session_id = '&amp;'.strip_tags(SID);
		$session_id2 = '&amp;'.strip_tags(SID);
		if (
				(isset($_COOKIE[session_name()]) 
					and 
				$_COOKIE[session_name()] == session_id()
				) 
				or ((bool)ini_get("session.use_trans_sid") !== false)
			) {
			$session_id2 = "";
		}
	} else {
		$session_id = "";
		$session_id2 = "";
	}
	print_headers();	// send wml headers

	if ($clear_history) {?>
<card id="main" ontimer="<? echo $url.$session_id; ?>" title="<? echo $title; ?>" newcontext='true'>
	
	<? } else { ?>
<card id="main" ontimer="<? echo $url.$session_id; ?>" title="<? echo $title; ?>">
	
	<? } ?>

	<timer value="<? echo $delay; ?>" />
	<p>
	<u><? echo $title; ?></u><br />
	<? echo $message; ?>
	</p>
	<p align="center">
	<a href="<? echo $url. $session_id2 ?>"><? echo $gm_lang['continue'] ?></a><br />
	<!-- Please do not remove the following lines -->
	<small>
	Powered by:<br />
	gmail-mobile
	</small>
	</p>
	<?
	print_footer();
}

function print_footer() {
	echo "</card>\n";
	echo "</wml>\n";
}

function sanitize_body($text) {

	//$text = str_replace(array("#229"),array("[blah blah]<br />\n"),$text);

	$keep_tags = "<br>";
	//$keep_tags = "<br><i><b><em><u>";
	
	// clean the message text, and removes unnecessary html tags like <div> and javascript

	// replace all html tags except <br> (save <br> for later)
	$text = str_replace(array("<br>","&nbsp;"),array("[br]\n"," "),strip_tags($text,$keep_tags));

	// replaces all active links
	//    or ' \8 [link \4\5] '
	$text = preg_replace('/(&lt;|<)a\s*href(=|u003d)(&quot;|")\s*(http:\/\/|mailto:)+(.*?)\s*(&quot;|")\s*(&gt;|>)\s*(.*?)\s*(&lt;|<)\/a(&gt;|>)/is', ' \8 [link] ', $text); 

//	$text = html_entity_decode($text);

	// html entities to uft-8
/* 	$trans_tbl = get_html_translation_table(HTML_ENTITIES); */
/* 	foreach($trans_tbl as $k => $v) { */
/* 		$ttr[$v] = utf8_encode($k); */
/* 	} */
/* 	$text = strtr($text, $ttr);  */

	// WML encode $ signs
	$text = str_replace(array("$"),array("$$"),$text);

	// remove attributes in the <br> tag
	$text = preg_replace('/(&lt;|<)br\s*?([a-zA-Z]*?)=(&quot;|")[^"]*?(&quot;|")\s*?(&gt;|>)/is', ' [br] ', $text); 

	// it's safe now to recode the [br]
	$text = str_replace("[br]","<br />",$text);
	
	return $text;

}

function debug_print($str,$debug_filename = "") {
	global $D_FILE;
	$debug_filename = ($debug_filename != "") ? $debug_filename : $D_FILE ; 
	$fd = fopen($debug_filename, "a+");
	fwrite($fd, "<?php /**\n".date("l jS of F Y h:i:s A",time())."\n".$str." **/ ?".">\n");
	fclose($fd);
}

function print_headers($type = "") {

	$charset = "UTF-8";

	if (isset($_SESSION['gm_lang'])) {
		switch ($_SESSION['gm_lang']) {
			case "zh-TW": $charset = "big5";	break;
			case "zh-CN": $charset = "big5";	break;
			//case "ja"	: $charset = "big5";	break;
			//case "ko"	: $charset = "big5";	break;
			//case "ru"	: $charset = "big5";	break;
		}
	}
	
	// set the correct MIME document type
	if ($type == "html") {
		// for html attachments page
		header("Content-type: text/html; charset=".$charset);
	} else {
		// WML
		header("Content-type: text/vnd.wap.wml; charset=".$charset);
	}
	
	// Expire date in the past
	header("Expires: Mon, 26 Jul 1997 05:00:00 GMT");
	
	// always modified
	header("Last-Modified: " . gmdate("D, d M Y H:i:s") . " GMT");
	 
	// Prevent caching, HTTP/1.1
	//header("Cache-Control: no-cache, must-revalidate");
	header("Cache-Control: no-store, no-cache, must-revalidate",true);
	header("Cache-Control: post-check=0, pre-check=0", false);

	// For SprintPCS-Nextel, possibly others, to prevent compression by the gateway
	if (
			((isset($_SESSION['gm_no_transform']) and $_SESSION['gm_no_transform'])
		//or ((isset($_ENV['HTTP_CLIENTID'])) and (strpos($_ENV['HTTP_CLIENTID'], "@sprintpcs.com") !== false))
		or ((isset($_ENV['HTTP_VIA'])) and (strpos($_ENV['HTTP_VIA'], ".sprintspectrum.com:") !== false))
		or ((isset($_ENV['HTTP_X_UP_UPLINK'])) and (strpos($_ENV['HTTP_X_UP_UPLINK'], ".upl.sprintpcs.com") !== false))
		)
		// and ((isset($_ENV['HTTP_X_UP_UPLINK'])) and (strpos($_ENV['HTTP_X_UP_UPLINK'], ".nexteldata.net") === false))
		//or ((isset($_ENV['HTTP_X_UP_UPLINK'])) and (strpos($_ENV['HTTP_X_UP_UPLINK'], ".nextelinternational.com") !== false))
		) {
		header("Cache-Control: no-transform", false);
	}
	
	// Prevent caching, HTTP/1.0
	header("Pragma: no-cache");

	//header("Cache-Control: max-age=1,  s-maxage=1");		// caches for only 1 second
		
	// wap document
	if ($type == "html") {
		// for html attachments page
		echo "<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\""." \"http://www.w3.org/TR/html4/loose.dtd\">";
	} else {
		// WML
		echo "<?xml version=\"1.0\"?".">"; 
		echo "<!DOCTYPE wml PUBLIC \"-//WAPFORUM//DTD WML 1.1//EN\""." \"http://www.wapforum.org/DTD/wml_1.1.xml\">";
		//echo "<!DOCTYPE wml PUBLIC \"-//WAPFORUM//DTD WML 1.2//EN\""." \"http://www.wapforum.org/DTD/wml12.dtd\">";
		//echo "<!DOCTYPE wml PUBLIC \"-//WAPFORUM//DTD WML 1.3//EN\""." \"http://www.wapforum.org/DTD/wml13.dtd\">";

		echo "<wml>\n";
	
		echo "<head>\n";
		echo "<meta http-equiv=\"Cache-Control\" content=\"max-age=1, must-revalidate, no-cache\" forua=\"true\" />\n";
		global $conf;
		global $use_pin;
		global $pin_user_found;
		$url = "http://".HOST.((dirname(SELF) != "/") ? dirname(SELF) : "");
		if (basename(SELF) == "index.php" and $conf['use_pin'] and $use_pin and $pin_user_found) {
			global $fuser;
			$url .= "/index.php?u=".$fuser."&amp;up=1";
		}
		echo "<meta name=\"vnd.up.bookmark\" content=\"".$url."\" />\n";
		echo "</head>\n";
	}
}

//
// END: Functions
//
/////////////////////////

?>