<?
/****************************************************************

gmail-mobile (a.k.a. unofficial Gmail Mobile)
Copyright (c) 2005, 2006
Neerav Modi and others

Version 0.11 (c) 2004
GAN Ying Hung, Rudi Pittman, Gaston Annebicque

Licensed under the GNU GPL. For full terms see the file COPYING.

gmail-mobile (unofficial Gmail Mobile since Sept 2004) provides
access to Gmail accounts with any WAP enabled phone or hand held
(in WML format).

http://gmail-mobile.sourceforge.net

*****************************************************************/

require_once("libgmailer.php");
require_once("config.php");

// to prevent the session id to propagate further
ini_set('url_rewriter.tags', "");	

// create the gmail object
$gmailer = new GMailer();
// initialize connection
quick_init($gmailer);

// Connect to gmail and gmail object
$gmailer->connect();

if (isset($_SESSION['gm_language'])) {
	// Localization (l10n) phrases
	load_language();
}

$timezone = "";
if (isset($_SESSION['gm_time_zone'])) {
	$sub = substr($_SESSION['gm_time_zone'],0,1);
	if (	$sub != "-"
		and $sub != "+"
		and $sub != " "
		and $sub != 0
		) {
		$timezone = "&amp;timezone=+".$_SESSION['gm_time_zone'];
	} else {
		$timezone = "&amp;timezone=".$_SESSION['gm_time_zone'];
	}
}

$gmailer->disconnect();

// redirect
$url = "index.php?logout=1".$timezone;
$title = $gm_lang['signing_out'];
$message = $gm_lang['complete_sign_out'];

// actual redirection
redirect_page($url, $title, $message, 5,true);	

// MUST exit script after redirecting
exit();

?>
