<?
/****************************************************************

gmail-mobile (a.k.a. unofficial Gmail Mobile)
Copyright (c) 2005, 2006
Neerav Modi and others

Version 0.11 (c) 2004
GAN Ying Hung, Rudi Pittman, Gaston Annebicque

Licensed under the GNU GPL. For full terms see the file COPYING.

gmail-mobile (unofficial Gmail Mobile since Sept 2004) provides
access to Gmail accounts with any WAP enabled phone or hand held
(in WML format).

http://gmail-mobile.sourceforge.net

*****************************************************************/

require_once("libgmailer.php");
require_once("config.php");

// create the gmail object
$gmailer = new GMailer();
// initialize connection
quick_init($gmailer);

// Connect to gmail
connect_gmail();

// Localization (l10n) phrases
load_language();
																																						 
																																						 
$status = false;
$status_message = "";


$gmailer->fetchBox(GM_PREFERENCE, 0, 0);
$snapshot = $gmailer->getSnapshot(GM_PREFERENCE);
//$snapshot->personality;
//$snapshot->personality_unverify;

// for debugging
/* print_r($gmailer); */
//print_r($snapshot);
/* exit; */
	
print_headers();	// send wml headers
	?>
<template>
	<do type="prev" label="<? echo $gm_lang['back'] ?>" name="z"><prev/></do>
</template>
<card title="<? echo $gm_lang['accounts'] ?>" id='main'>
<p>
<?
// display a system-wide message
system_message();	

if ($status_message != "") echo "<em>".$status_message."</em><br /><br />\n";
?>
<b><? echo $gm_lang['accounts_settings'] ?></b><br />
<br />
----------<br />
<br />
<b><? echo $gm_lang['send_mail_as'] ?></b><br />
<small><? echo $gm_lang['send_mail_as_sub'] ?><br />
<br />
<?
	$default_address = -1;
	$person_count = count($snapshot->personality);
	for($i = 0; $i < $person_count; $i++) {
		if ($snapshot->personality[$i]['default']) {
			$default_address = $i;
			break;
		}
	}
	//echo "<b>";
	if ($_SESSION['gm_google_name'] == "") {
		echo "<b>".$_SESSION['gm_gmail_name']."</b>";
	} else {
		echo $_SESSION['gm_google_name']."<br />\n<b>".$_SESSION['gm_gmail_name']."</b>";
	}
	
	echo "<br />\n";
	if ($default_address == -1) {
		echo "<b>".$gm_lang['default_lower']."</b><br />";
	} else {
		echo "[".$gm_lang['make_default_lower']."]<br />";
	}
	echo "[".$gm_lang['edit_info']."]<br />";
	echo "<br />\n";
	
	for ($i = 0; $i < $person_count; $i++) {
		$fromname = $snapshot->personality[$i]['name'];
		$fromemail = $snapshot->personality[$i]['email'];
		$replyto_email = $snapshot->personality[$i]['reply-to'];
		
		//echo "<b>";
		if ($fromname == "") {
			echo "<b>".$fromemail."</b>";
		} else {
			echo $fromname."<br />\n<b>".$fromemail."</b>";
		}
		echo "<br />\n";
		if ($replyto_email != "") echo $gm_lang['reply_to_address_col']." ".$replyto_email."<br />";

		if ($default_address == $i) {
			echo "<b>".$gm_lang['default_lower']."</b><br />";
		} else {
			echo "[".$gm_lang['make_default_lower']."]<br />";
		}
		echo "[".$gm_lang['edit_info']."]<br />";
		echo "[".$gm_lang['delete_lower']."]<br />";

		echo "<br />\n";
	}

	$person_count = count($snapshot->personality_unverify);
	for ($i = 0; $i < $person_count; $i++) {
		$fromname = $snapshot->personality_unverify[$i]['name'];
		$fromemail = $snapshot->personality_unverify[$i]['email'];
		$replyto_email = $snapshot->personality_unverify[$i]['reply-to'];
		
		if ($fromname == "") {
			echo "<b>".$fromemail."</b>";
		} else {
			echo $fromname."<br />\n<b>".$fromemail."</b>";
		}
		echo "<br />\n";
		if ($replyto_email != "") echo $gm_lang['reply_to_address_col']." ".$replyto_email."<br />";
		echo "<b>".$gm_lang['unverified']."</b><br />";
		echo "[".$gm_lang['edit_info']."]<br />";
		echo "[".$gm_lang['delete_lower']."]<br />";

		
		echo "<br />\n";
	}
?>
</small>
----------<br />
<br />
<b><? echo $gm_lang['google_acct_settings'] ?></b><br />
<br />
<? echo $gm_lang['visit_google_acct'] ?><br />
<br />
----------<br />
<br />


<? echo "<a href='setting.php?".RANDOM.GMID."'>".$gm_lang['cancel']."</a><br />\n"; ?>
<?
echo "--------<br />";
echo "<a href='setting.php?".RANDOM.GMID."'>".$gm_lang['settings']."</a><br />\n";
echo "<a href='main.php?sum=1".RANDOM.GMID."'>".$gm_lang['summary']."</a><br />\n";
echo "<a href='compose.php?action=new&amp;back=general.php".RANDOM.GMID."'>".$gm_lang['compose_mail']."</a><br />\n";
echo "<a href='logout.php?".RANDOM.GMID."'>".$gm_lang['sign_out']."</a>\n";
echo "</p>\n";

print_footer();

?>