<?
/****************************************************************

gmail-mobile (a.k.a. unofficial Gmail Mobile)
Copyright (c) 2005, 2006
Neerav Modi and others

Version 0.11 (c) 2004
GAN Ying Hung, Rudi Pittman, Gaston Annebicque

Licensed under the GNU GPL. For full terms see the file COPYING.

gmail-mobile (unofficial Gmail Mobile since Sept 2004) provides
access to Gmail accounts with any WAP enabled phone or hand held
(in WML format).

http://gmail-mobile.sourceforge.net

*****************************************************************/

require_once("libgmailer.php");
require_once("config.php");

// create the gmail object
$gmailer = new GMailer();
// initialize connection
quick_init($gmailer);

// Connect to gmail
connect_gmail();
																																						 
// Localization (l10n) phrases
load_language();
																																						 
$thread = (isset($_REQUEST['th'])) 		? $_REQUEST['th'] 		: 0;
$msg 	= (isset($_REQUEST['mg'])) 		? $_REQUEST['mg'] 		: 0;
$attach = (isset($_REQUEST['a'])) 		? $_REQUEST['a'] 		: 0;
$aid	= (isset($_REQUEST['aid'])) 	? $_REQUEST['aid'] 		: 0;
$aname 	= (isset($_REQUEST['aname'])) 	? $_REQUEST['aname'] 	: "";
/* $zipped = (isset($_REQUEST['z'])) 		? $_REQUEST['z'] 	: 0; */

/* 	if ($zipped) { */
/* 		header("Content-Type: application/octet-stream"); */
/* 		header('Content-Disposition: attachment; filename="'.$msgid.'.zip"'); */
/* 		@$gmailer->getAttachment($attid, $msgid, "php://output", true);             */
/* 		exit();   */
/* 	} */

// download the attachment
if ($aid) {
	// an inline image
	$attach_exten = get_ext($aname);
	
	switch($attach_exten) {
		case "jpg": 	header("Content-Type: image/jpg");	break;
		case "jpeg": 	header("Content-Type: image/jpg");	break;
		case "gif": 	header("Content-Type: image/gif");	break;
		case "png": 	header("Content-Type: image/png");	break;
		case "bmp": 	header("Content-Type: image/bmp");	break;
		case "wbmp": 	header("Content-Type: image/wbmp");	break;
		default:		header("Content-Type: image/*");	break;
	}
	if ($aname == "") $aname = "unnamed_image";
	header('Content-Disposition: attachment; filename="'.str_replace(" ", "_", $aname).'"');
	@$gmailer->getAttachment($aid, $_SESSION['gm_attachment_msg_id'], "php://output", false);            
	exit();
	
} elseif ($attach) {
	// an attachment
	$snapshot = $_SESSION['gm_attachment_message_cache'];
	$attid 	= $snapshot->conv[0]['attachment'][$attach-1]['id'];
	$type 	= $snapshot->conv[0]['attachment'][$attach-1]['type'];
	$fname	= $snapshot->conv[0]['attachment'][$attach-1]['filename'];
	$size	= $snapshot->conv[0]['attachment'][$attach-1]['size'];

	$type = correct_mime($type,$fname);
	header("Content-Type: ".$type);
	header("Content-Length: ".$size);
	header('Content-Disposition: attachment; filename="'.str_replace(" ", "_", $fname).'"');
	@$gmailer->getAttachment($attid, $_SESSION['gm_attachment_msg_id'], "php://output", false);            
	exit();
	
} else {
	if ($msg)
		$q = "search=inbox&view=cv&th=".$thread."&msgs=".$msg;      
	else
		$q = "search=inbox&view=cv&th=".$thread."&msgs=".$thread;
	
	$gmailer->fetch($q);
	$snapshot = $gmailer->getSnapshot(GM_CONVERSATION);
	if ($snapshot->created == 0) static_error($snapshot->snapshot_error);
	$_SESSION['gm_attachment_message_cache'] = $snapshot;
	//debug_print(print_r($gmailer,true));
	//debug_print(print_r($snapshot,true));
}

if (!isset($snapshot->conv)) {
	if (!isset($snapshot->snapshot_error)) {
		//debug_print("attach: 110, conv AND snapshot_error undefined?!?: ".print_r($snapshot,true));
		//debug_print("attach: 110, conv AND snapshot_error undefined?!?: dumping gmail response: ".print_r($gmailer->debug_gmail_response(),true));
	}
		
	// msg not found, redirect to last mailbox
	msg_not_found($snapshot->snapshot_error);

} else {
	$msgid = ($msg > 0) ? $msg : $snapshot->conv[0]['id'] ;
	$_SESSION['gm_attachment_msg_id'] = $msgid;
	$_SESSION['gm_attachment_thread_id'] = $thread;
}

// display attachment listing

print_headers();	// send wml headers
?>
<template>
	<do type="prev" label="<? echo $gm_lang['back'] ?>" name="z"><prev/></do>
</template>
<?
echo "<card title='".$gm_lang['attachments']."' id='main'>\n";
echo "<p>\n";

// display a system-wide message
system_message();	

echo "<small>\n";

$on = "";
$off = "";

if ($conf['view_attach_html']) {
	$on .= ($on != "") ? ", ".$gm_lang['view_html'] : $gm_lang['view_html'] ;
	//echo $gm_lang['view_html']." <b>".$gm_lang['on_cap']."</b><br />\n";
} else {
	//echo $gm_lang['view_html']." <b>".$gm_lang['off_cap']."</b><br />\n";
	$off .= ($off != "") ? ", ".$gm_lang['view_html'] : $gm_lang['view_html'] ;
}

if ($conf['view_attach_image']) {
	//echo $gm_lang['view_image']." <b>".$gm_lang['on_cap']."</b><br />\n";
	$on .= ($on != "") ? ", ".$gm_lang['view_image'] : $gm_lang['view_image'] ;
} else {
	//echo $gm_lang['view_image']." <b>".$gm_lang['off_cap']."</b><br />\n";
	$off .= ($off != "") ? ", ".$gm_lang['view_image'] : $gm_lang['view_image'] ;
}

if ($conf['view_attach_audio']) {
	//echo $gm_lang['dl_audio']." <b>".$gm_lang['on_cap']."</b><br />\n";
	$on .= ($on != "") ? ", ".$gm_lang['dl_audio'] : $gm_lang['dl_audio'] ;
} else {
	//echo $gm_lang['dl_audio']." <b>".$gm_lang['off_cap']."</b><br />\n";
	$off .= ($off != "") ? ", ".$gm_lang['dl_audio'] : $gm_lang['dl_audio'] ;
}

if ($conf['view_attach_video']) {
	//echo $gm_lang['dl_video']." <b>".$gm_lang['on_cap']."</b><br />\n";
	$on .= ($on != "") ? ", ".$gm_lang['dl_video'] : $gm_lang['dl_video'] ;
} else {
	//echo $gm_lang['dl_video']." <b>".$gm_lang['off_cap']."</b><br />\n";
	$off .= ($off != "") ? ", ".$gm_lang['dl_video'] : $gm_lang['dl_video'] ;
}

if ($conf['view_attach_zip']) {
	//echo $gm_lang['dl_zip']." <b>".$gm_lang['on_cap']."</b><br />\n";
	$on .= ($on != "") ? ", ".$gm_lang['dl_zip'] : $gm_lang['dl_zip'] ;
} else {
	//echo $gm_lang['dl_zip']." <b>".$gm_lang['off_cap']."</b><br />\n";
	$off .= ($off != "") ? ", ".$gm_lang['dl_zip'] : $gm_lang['dl_zip'] ;
}

if ($conf['view_attach_other']) {
	//echo $gm_lang['dl_other']." <b>".$gm_lang['on_cap']."</b><br />\n";
	$on .= ($on != "") ? ", ".$gm_lang['dl_other'] : $gm_lang['dl_other'] ;
} else {
	//echo $gm_lang['dl_other']." <b>".$gm_lang['off_cap']."</b><br />\n";
	$off .= ($off != "") ? ", ".$gm_lang['dl_other'] : $gm_lang['dl_other'] ;
}

echo "<b>Download Status:</b><br />\n";
if ($on != "") echo "<b>".$gm_lang['on_cap']."</b>: ".$on."<br />";
if ($off != "") echo "<b>".$gm_lang['off_cap']."</b>: ".$off."<br />";


if ($conf['attach_size_limit'] != 0) {
	echo sprintf($gm_lang['size_limit'],$conf['attach_size_limit'])."<br />\n";
}

echo "<br />";
echo $gm_lang['only_if_supported']."<br /><br /></small>\n";

//debug_print("attachments: dump: ".print_r($snapshot->conv[0]['attachment'],true));

$attachment_count = count($snapshot->conv[0]['attachment']);
for ($i=0;$i<$attachment_count;$i++) {
	$type 	= trim($snapshot->conv[0]['attachment'][$i]['type']);
	$fname	= $snapshot->conv[0]['attachment'][$i]['filename'];
	$size 	= ceil($snapshot->conv[0]['attachment'][$i]['size']/1024);
	$mime 	= substr($type,0,5);

	if (
			(
				($conf['view_attach_image'] and ($mime == "image"))
					or
				($conf['view_attach_audio'] and ($mime == "audio"))
					or
				($conf['view_attach_html'] and ($type == 'text/html'))
					or
				($conf['view_attach_video'] and ($mime == "video"))
					or
				($conf['view_attach_zip'] and (($type == "application/zip") or ($type == "application/x-zip-compressed")))
					or
				($conf['view_attach_other'])
			)
				and
			(
				($conf['attach_size_limit'] == 0)
					or
				($size <= $conf['attach_size_limit'])
			)
		) {
		$id = $i+1;
/* 		echo "<a href=\"".basename(SELF)."?a=$id&amp;th=$thread&amp;mg=$msgid.GMID\">".$fname."</a><br />\n"; */
		echo "<a href=\"".basename(SELF)."?a=$id".GMID."\">".$fname."</a><br />\n";
	} else {
		echo $fname."<br />\n";
	}
	$type = correct_mime($type, $fname);
	echo $type." (".sprintf($gm_lang['kb'],$size).")<br /><br />\n";
}

$keep_tags = "<img>";
// replace all html tags except <br> (save <br> for later)
$text = str_replace(array("<br>","&nbsp;"),array("[br]\n"," "),strip_tags($snapshot->conv[0]['body'],$keep_tags));
$text = explode("<img ",$text);
$img_count = count($text);

//debug_print(print_r($text,true));

// an inline image	
if ($img_count > 0) {
	for ($i = 0 ; $i < $img_count; $i++) {
		eregi('/mail/\?.*attid=([^&]*)&amp;th=(.* alt="([^"]*))?', $text[$i], $matches);
		if ($matches[1] != "") {
			if ($conf['view_attach_image']) {
				if ($matches[3] != "") {
					echo "<a href=\"".basename(SELF)."?aid=".$matches[1].
						"&amp;aname=".urlencode($matches[3]).GMID."\">".
						cleanse_string($matches[3])."</a><br />\n";
				} else {
					echo "unnamed<br />\n";
				}
			} else {
				echo cleanse_string((($matches[3] != "")  ? $matches[3] : "unnamed" ))."<br />\n";
			}
			echo $gm_lang['inline_image']." ".$gm_lang['unknown_paren']."<br /><br />\n";
		}
	}
	
}

echo "<anchor>".$gm_lang['back_to_conv']."<prev/></anchor><br />\n";
echo "<a href=\"main.php?".GMID."\">".sprintf($gm_lang['back_to'],$_SESSION['gm_backto'])."</a><br />\n";
echo "</p>\n";
print_footer();


function get_ext($file_name) {
	$file_ext = array_pop(explode('.', $file_name));
	return $file_ext;
}

function correct_mime($mime_type, $filename) {
	if (($mime_type == "application/zip") or ($mime_type == "application/x-zip-compressed")) {
		if (get_ext($filename) == "jar") $mime_type = "application/java-archive";
	} elseif ($mime_type == "application/octet-stream") {
		switch(get_ext($filename)) {
			case "sis":		$mime_type = "application/vnd.symbian.install";	break;
			default:										break;
		}
	}
	return $mime_type;
}

?>