<?
/****************************************************************

gmail-mobile (a.k.a. unofficial Gmail Mobile)
Copyright (c) 2005, 2006
Neerav Modi and others

Version 0.11 (c) 2004
GAN Ying Hung, Rudi Pittman, Gaston Annebicque

Licensed under the GNU GPL. For full terms see the file COPYING.

gmail-mobile (unofficial Gmail Mobile since Sept 2004) provides
access to Gmail accounts with any WAP enabled phone or hand held
(in WML format).

http://gmail-mobile.sourceforge.net

*****************************************************************/

require_once("libgmailer.php");
require_once("config.php");

// create the gmail object
$gmailer = new GMailer();
// initialize connection
quick_init($gmailer);

// Connect to gmail
connect_gmail();

// Localization (l10n) phrases
load_language();
																																						 
$status = false;
$status_message = "";

if (isset($_GET['act']) and $_GET['act'] == "save") {
	$forward		= (isset($_POST['forward'])) 		? $_POST['forward']	: 0;
	$forward_to 	= (isset($_POST['forward_to'])) 	? $_POST['forward_to']: "";
	$forward_action	= (isset($_POST['forward_action'])) ? $_POST['forward_action']	: 0;
	$pop_enabled	= (isset($_POST['pop_enabled'])) 	? $_POST['pop_enabled']	: 0;
	$pop_action		= (isset($_POST['pop_action'])) 	? $_POST['pop_action']	: 0;

	$forward_to 	= stripslashes(trim($forward_to));
	
	// perform the action
	$status = $gmailer->setSetting(
		$_SESSION['gm_setting_gen_cache']['language'],
		$_SESSION['gm_setting_gen_cache']['page_size'],
		$_SESSION['gm_setting_gen_cache']['shortcuts'],
		$_SESSION['gm_setting_gen_cache']['p_indicator'],
		$_SESSION['gm_setting_gen_cache']['show_snippets'],
		$_SESSION['gm_setting_gen_cache']['use_signature'],
		$_SESSION['gm_setting_gen_cache']['signature'],
		$_SESSION['gm_setting_gen_cache']['encoding'],
		$forward,
		(($forward) ? $forward_to : ""),
		$forward_action,
		$pop_enabled,
		$pop_action,
		$_SESSION['gm_setting_other_cache']['rich_text'],
		$_SESSION['gm_setting_gen_cache']['encoding'],
		$_SESSION['gm_setting_gen_cache']['encoding'],
		$_SESSION['gm_setting_other_cache']['expand_labels'],
		$_SESSION['gm_setting_other_cache']['expand_invites'],
		$_SESSION['gm_setting_gen_cache']['vacation_enabled'],
		$_SESSION['gm_setting_gen_cache']['vacation_subject'],
		$_SESSION['gm_setting_gen_cache']['vacation_message'],
		$_SESSION['gm_setting_gen_cache']['vacation_contact']
	);

	$status_message	= $gmailer->lastActionStatus('message');

} 

$gmailer->fetchBox(GM_PREFERENCE, 0, 0);
$snapshot = $gmailer->getSnapshot(GM_PREFERENCE);
if ($snapshot->created == 0) static_error($snapshot->snapshot_error);
$setting = $snapshot->setting_fpop;
$_SESSION['gm_setting_gen_cache'] = $snapshot->setting_gen;
$_SESSION['gm_setting_fpop_cache'] = $snapshot->setting_fpop;
$_SESSION['gm_setting_other_cache'] = $snapshot->setting_other;
$_SESSION['gm_setting_mobile_cache'] = $snapshot->setting_mobile;
$_SESSION['gm_display_boxes'] = $_SESSION['gm_setting_mobile_cache']['display_boxes'];

// for debugging
//debug_print("Gmailer object: ".print_r($gmailer,true));
//debug_print("fpop snapshot: ".print_r($snapshot,true));
/* exit; */
	
print_headers();	// send wml headers
include("template.php");	// print template
	?>
<card title="<? echo $gm_lang['general'] ?>" id='main'>
<onevent type="onenterforward">
<refresh>
<setvar name="forward" value="<? echo $setting['forward'] ?>" />
<setvar name="forward_to" value="<? echo $setting['forward_to'] ?>" />
<setvar name="forward_action" value="<? echo $setting['forward_action'] ?>" />
<setvar name="pop_enabled" value="<? echo $setting['pop_enabled'] ?>" />
<setvar name="pop_action" value="<? echo cleanse_string($setting['pop_action']) ?>" />
</refresh>
</onevent>
<p>
<?
// display a system-wide message
system_message();	

if ($status_message != "") echo "<em>".$status_message."</em><br /><br />\n";
?>
<b><? echo $gm_lang['forwarding_pop']?></b><br />
<br />
<b><? echo $gm_lang['forwarding_col'] ?></b><br />
<select title="<? echo $gm_lang['forwarding_col'] ?>" name="forward">
	<option value="0"><? echo $gm_lang['disable_forward'] ?></option>
	<option value="1"><? echo $gm_lang['forward_copy_to'] ?></option>
</select>
<small><? echo $gm_lang['forward_copy_to_col'] ?></small>
<input title="<? echo $gm_lang['forward_to_email']?>" name="forward_to" format="*m" emptyok="true" />
<? echo $gm_lang['and'] ?><br />
<select title="<? echo $gm_lang['forwarding_col'] ?>" name="forward_action">
	<option value="0"><? echo $gm_lang['forward_and_keep'] ?></option>
	<option value="1"><? echo $gm_lang['forward_and_archive'] ?></option>
	<option value="2"><? echo $gm_lang['forward_and_trash'] ?></option>
</select>
<small><? echo sprintf($gm_lang['forward_tip'], strip_tags(SID)) ?></small><br />
<br />


<? echo "<a href='setting.php?".RANDOM.GMID."'>".$gm_lang['cancel']."</a><br />\n"; ?>
<anchor title="<? echo $gm_lang['save_changes'] ?>"><go href="<? echo basename(SELF).'?act=save&amp;'.strip_tags(SID) ?>" method="post">
	<postfield name="forward" value="$(forward)" />
	<postfield name="forward_to" value="$(forward_to)" />
	<postfield name="forward_action" value="$(forward_action)" />
	<postfield name="pop_enabled" value="$(pop_enabled)" />
	<postfield name="pop_action" value="$(pop_action)" />
</go><? echo $gm_lang['save_changes'] ?></anchor>
<br />
<?
if ($_SESSION['gm_links_display'] != 2) {
	echo "--------<br />";
	echo "<a href='setting.php?".RANDOM.GMID."'>".$gm_lang['settings']."</a><br />\n";
	echo "<a href='main.php?sum=1".RANDOM.GMID."'>".$gm_lang['summary']."</a><br />\n";
	echo "<a href='compose.php?action=new&amp;back=".basename(SELF).RANDOM.GMID."'>".$gm_lang['compose_mail']."</a><br />\n";
	echo "<a href='logout.php?".RANDOM.GMID."'>".$gm_lang['sign_out']."</a>\n";
}
echo "</p>\n";

print_footer();

?>