<?
/****************************************************************

gmail-mobile (a.k.a. unofficial Gmail Mobile)
Copyright (c) 2005, 2006
Neerav Modi and others

Version 0.11 (c) 2004
GAN Ying Hung, Rudi Pittman, Gaston Annebicque

Licensed under the GNU GPL. For full terms see the file COPYING.

gmail-mobile (unofficial Gmail Mobile since Sept 2004) provides
access to Gmail accounts with any WAP enabled phone or hand held
(in WML format).

http://gmail-mobile.sourceforge.net

*****************************************************************/

// PIN sign-in based on concept by Kristian Eide <kreide AT gmail DOT com>

// Unfortunately, the simple concept was mercilessly tortured by Neerav
//   until it eventually gave in and mutated into the horrible beast
//   it is today. ;-)  Help! It's PINzilla!

require_once("libgmailer.php");
require_once("config.php");

$username 	= "";
$token 		= "";
$div 		= "=:=";
$pin_field	= 3;
$timezone 	= "";
$user 		= "";
$pass 		= "";
$err 		= "";
$status 	= "";
$use_pin	= (isset($_REQUEST['up'])) ? $_REQUEST['up'] : 0 ;

// An attempt to deliver the login challenge graphic
// A graphic displays, unfortunately, not the correct one...
/* if (isset($_GET['log_png']) and $_GET['log_png'] == 1) { */
/* 	// create the gmail object */
/* 	$gmailer = new GMailer(); */
/* 	// initialize connection */
/* 	//quick_init($gmailer); */
/* 	$username = $_GET['username']; */
/* 	$token = $_GET['token']; */
/* 	//echo "<br />\nuser: $username<br />\ntoken: $token<br />\n"; */
/* 	header("Content-Type: image/jpg"); */
/* 	//echo "success: login failure"; */
/* 	echo $gmailer->retrieveCaptcha($username,$token); */
/* 	//echo $_SESSION['gm_login_png']; */
/* 	//fpassthru($_SESSION['gm_login_png']); */
/* 	exit; */
/* } */

// PIN code user check
$pin_user_found = false;
$all_user_data 	= "";
$pin_filename 	= $conf['temp_dir']."user_pin.php";
$expire_time 	= time() - 345600;	// 4 days
$fuser 			= "";
$ftzone 		= 0;
if (!$conf['use_pin'] and file_exists("$pin_filename")) {
	unlink("$pin_filename");

} elseif ($conf['use_pin'] and $use_pin and isset($_REQUEST['user'])) {
	if (!file_exists("$pin_filename")) {
		// PIN file doesn't exist
		touch("$pin_filename");
		chmod("$pin_filename",0600);
	} else {
		$user = strtolower(stripslashes(trim($_REQUEST['user'])));
		$user = ereg_replace("@.*$", '', $user);
		if ($all_user_info = file("$pin_filename")) {
			$pin_count = count($all_user_info);
			for($i = $pin_count-1; $i >= 0; $i--) {
				$user_data = explode(" ",$all_user_info[$i]);
				if (count($user_data) < 3) continue;
				// invalid PIN format, skip
				if ( 	(count($user_data) != ($pin_field+2+1))
					 or (!isset($user_data[0]))
					 or (!isset($user_data[1]))
					 or ($user_data[0] != '<?') 
					 or ($user_data[1] != '/*')
					) continue;
				// expired PINs
				if ($user_data[2] < $expire_time) continue;

				@list($cryptuser, $ftime, $fpin, $fpass, $ftzone, $ftrials) = split($div, base64_decode(trim($user_data[$pin_field])));
				if (($cryptuser != "") and (crypt($user,$cryptuser) == $cryptuser)) {
					$fuser = $user;
					$pin_user_found = true;
					break;
				}/*  else { */
/* 					$fuser = $user; */
/* 					$ftzone = 0; */
/* 				} */
			}
		}
	}
}
if (!$pin_user_found and isset($_REQUEST['user'])) {
	$fuser = ereg_replace("@.*$", '', strtolower(stripslashes(trim($_REQUEST['user']))));
	$ftzone = 0;
}

/////////////////
//
//	Login
//

if ((isset($_POST['signin'])) and ($_POST['signin'] == "si")) {

	// create the gmail object
	$gmailer = new GMailer();
	// initialize connection
	quick_init($gmailer);
	
	$user = strtolower(stripslashes(trim($_POST['user'])));
	$user = ereg_replace("@.*$", '', $user);

	if (($pin_user_found) and (isset($_POST["pin"]))) {
		$pin = stripslashes(trim($_POST["pin"]));

		if ($fpin == $pin) {
			$pass = str_rot13($fpass);
			$user = $fuser;
			$timezone = $ftzone;
			$status = "p";
		} else {
			$err = 30;
			$status = "-p";

			$ftrials++;
			if ($ftrials >=3) {
				pin_edit($user,"delete","");
				$pin_user_found = false;
			} else {
				$pin_string = time()." ".base64_encode(crypt($fuser,$fuser).$div.$ftime.$div.$fpin.$div.$fpass.$div.$ftzone.$div.$ftrials);
				pin_edit($user,"replace",$pin_string);
			}
		}

	} else {
		$pass 		= (isset($_POST['pass'])) ? trim($_POST['pass']) : "";
		$pass 		= str_replace(array("'",">","<","\""," "),
						array("&#39;","&#62;","&#60;","&#34;","+"),
						stripslashes($pass));
	}
	
	
	if ($err >= 30 and $err < 40) {
		// do not attempt a login
		// incorrect PIN code or PIN file does not exist
	
	} elseif ($user == '$(user)' or $pass == '$(pass)') {
		// browser sent improper info
		$err = 13;
		$status = "x";
	} elseif ($user != "" and $pass != "") {

		if ($timezone == "") {
			// set the timezone or use the default from config.php
			if (isset($_POST['timezone'])) 	$timezone = 0+$_POST['timezone'];
			else							$timezone = 0+$conf['time_zone'];
		}
		
		if ($timezone == 0) 				  $_SESSION['gm_time_zone'] = 0;
		elseif (substr($timezone,0,1) != "-") $_SESSION['gm_time_zone'] = "+".$timezone;
		else								  $_SESSION['gm_time_zone'] = $timezone;
		
		// set login information / login to Gmail
		$gmailer->setLoginInfo($user, $pass, $timezone);
		
/* 		$_SESSION['gm_show_labels'] = false; */
	
		if (!$gmailer->connect()) { // if not connected to gmail, error
	
			$login_error = $gmailer->lastActionStatus('login_error');
			//debug_print("loginerror: ".$login_error);
	
			$username = $user;		// duplicate because we can't use $user later
			
			if ($login_error == "userpass") {
				// user/password error
				$err = 10;
				$status = 0;

			} elseif ($login_error == "challenge") {
				// login challenge
				$err = 12;
				$login_token = $gmailer->lastActionStatus('login_token');
				//$_SESSION['gm_login_png'] = $gmailer->lastActionStatus('login_token_img');
				$status = -1;

			} elseif ($login_error == "URL") {
				// Gmail URL changed
				$err = 19;
				$status = "!URL!";

			} else {
				// connection error
				$err = 15;
				$status = "-";

			}
			
		} else {
			if ($status != "p") $status = 1;
			$delay = 1;
	
			$gmailer->fetch("search=cat&cat=dummyjusttoretrievesummary&view=tl&start=0&init=1");
			$snapshot = $gmailer->getSnapshot(GM_STANDARD|GM_LABEL|GM_QUERY|GM_CONVERSATION|GM_PREFERENCE);
			if ($snapshot->created == 0) static_error($snapshot->snapshot_error);
	
			$_SESSION['gm_search_query']  = "";
			$_SESSION['gm_last_box'] 	  = "login";
			$_SESSION['gm_gmail_name']	  = (isset($snapshot->gmail_email)) ? $snapshot->gmail_email : "";
			$_SESSION['gm_google_name']	  = (isset($snapshot->google_name)) ? $snapshot->google_name : "";
			$_SESSION['gm_from_addresses']= (isset($snapshot->personality)) ? $snapshot->personality : array();
			$_SESSION['gm_display_boxes'] = (isset($snapshot->personality)) ? $snapshot->personality : array();
			$_SESSION['gm_language']	  = ((isset($snapshot->setting_gen['language'])) and ($snapshot->setting_gen['language'] != ""))
				? $snapshot->setting_gen['language']
				: "en"
				;
			$_SESSION['gm_signature']	  = 
				(isset($snapshot->signature) and ($snapshot->signature != "")) 
				? "\r\n\r\n--\r\n".$snapshot->signature 
				: ""
				;

			// Localization (l10n) phrases
			load_language();

			$mailbox_length_warn = 
				(
						isset($snapshot->setting_gen['page_size']) 
					and ($snapshot->setting_gen['page_size'] != "")
					and ($snapshot->setting_gen['page_size'] > 25)
				)
				? "<em>".sprintf($gm_lang['reduce_mailbox_size'],strip_tags(SID))."</em><br /><br />\n"
				: ""
				;

			$_SESSION['gm_setting_gen_cache'] = $snapshot->setting_gen;

			$_SESSION['gm_display_boxes'] = 
				(isset($snapshot->setting_mobile['display_boxes'])
				and count($snapshot->setting_mobile['display_boxes']) > 0)
				? $snapshot->setting_mobile['display_boxes']
				: array("inbox","starred","sent","drafts","all","spam","trash")
				;


			$pin_message = "";
			if (isset($_POST["newpin"])) {			
				$newpin = trim($_POST["newpin"]);
				
				if ($newpin == "") {
					$pin_message = "";
				} elseif ($newpin == '$(pass)') {
					$pin_message = "";
					//$delay = 20;
				} elseif (strlen($newpin) < 4) {
					$pin_message = "<br />".$gm_lang['pin_too_short']."<br />";
					$delay = 20;
				} elseif (!is_numeric($newpin)) {
					$pin_message = "<br />".$gm_lang['pin_not_number']."<br />";
					$delay = 20;
				} else {
					$wpass = str_rot13($pass);
					$all_user_data = "";
					$pin_string = time()." ".base64_encode(crypt($user,$user).$div.time().$div.$newpin.$div.$wpass.$div.$timezone.$div."0");
					pin_edit($user, "add", $pin_string);
					$pin_message = $gm_lang['pin_saved']."<br />";
					$delay = 10;
				}
			}

			$_SESSION['gm_welcome_msg'] = $mailbox_length_warn . sprintf($gm_lang['welcome'],$_SESSION['gm_gmail_name'])."<br /><br />\n";
			
			// redirect to main page
			$title = $gm_lang['signin'];
			
			$message = "<b>".$gm_lang['successful']."</b><br />".$pin_message.$gm_lang['showing_sum'];
			
			// actual redirection
			redirect_page("main.php?sum=1", $title, $message, $delay, true);	
		
			// MUST exit script after redirecting
			exit();
		
		}
	} else {
		// field left blank
		$err = 11;
		$status = "x";

	}
} 
//
//	END: Login
//
/////////////////

// List of preset time zones.
// Used to create the timezone menu
// and check the validity of the config setting
$time_zones = array(
		"-12","-11","-10","-9","-8","-7","-6","-5","-4","-3.5","-3","-2.5","-2","-1",
		"0", // UTC/GMT
		"+1","+2","+3","+3.5","+4","+4.5","+5","+5.5","+5.75","+6","+6.5","+7","+8","+9","+9.5","+10","+10.5","+11","+11.5","+12","+13"	
);

// set logout flag
$logout = (isset($_GET['logout'])) 	? $_GET['logout'] 	: 0;

// sets the user name if supplied in the url (personal bookmark)
$user = (isset($_GET['u'])) 		? strtolower(stripslashes(trim($_GET['u']))) 		: "" ;
// legacy support for "login" variable
$user = (isset($_GET['login'])) 	? strtolower(stripslashes(trim($_GET['login'])))	: $user ;
$user = ereg_replace("@.*$", '', $user);

// sets the error
if (isset($_GET['err'])) $err = $_GET['err'];

// sets an error if the password if supplied in the url (personal bookmark)
if (isset($_GET['p']) or isset($_GET['pass'])) {
	$err = 50;
}

// for maintenence
//if ($err != "") $err = 18;
//$err = 18;
// Gmail is down
//$err = 19;

// a list of valid error messages

$errors = array(
	 0	=>	""
	,1	=>	"gmail-mobile: you have to Sign in first."
	,10	=>	"Username and password do not match. (You provided $username)"
	,11 =>	"Required field cannot be left blank"
	,12	=>	"Login challenge"
	,13 =>	"gmail-mobile: invalid sign-in information. Use another wap browser."
	,15	=>	"gmail-mobile or Gmail connection error."
	,16	=>	"Session timed out (non-ik). Sign in again."
	,17	=>	"Session timed out. Sign in again."
	,18	=>	"Sorry. gmail-mobile under maintenence.  Please try again after a few minutes."
	,19	=>	"Gmail changed something which has broken gmail-mobile. :-( Hopefully this can be fixed soon."
	,20	=>	"gmail-mobile: not really connected to Gmail.  Please sign in again."
	,30 =>	"gmail-mobile: invalid PIN code."
	,31 =>	"gmail-mobile: PIN not found."
	,32 =>	"gmail-mobile: Error reading PIN."
	,33 =>	"PIN for Username &quot;".$fuser."&quot; not found.  The PIN may have been deleted (3 wrong attempts) or expired (after 4 days) for security. <small> <a href=\"pin.php\">What is PIN Sign-in?</a></small>"
	,40 =>	"Gmail (not gmail-mobile) has returned you to the Sign In screen.  Please contact me with details so I can figure out why."
	,50 =>	"Remove your password from the bookmark.  It is a security risk.  Use the PIN Sign-in feature.  And change your password."
);

// set the timezone
// make sure the request or the config is valid
if ((isset($_REQUEST['timezone'])) 
	and (in_array($_REQUEST['timezone'],$time_zones))) {
	$timezone = $_REQUEST['timezone'];
} elseif ((isset($_REQUEST['tz'])) 
	and (in_array($_REQUEST['tz'],$time_zones))) {
	$timezone = $_REQUEST['tz'];
} elseif (in_array($conf_time_zone, $time_zones)) {
	$timezone = $conf_time_zone;
} else {
	$timezone = "0";
}
$sub = substr($timezone,0,1);
if (	$sub != "-"
	and $sub != "+"
	and $sub != " "
	and $timezone != 0
	) {
	$timezone = "+".$timezone;
}

// print the headers
print_headers();

if ($conf['use_pin'] and $use_pin and $pin_user_found) {
	$sub = substr($ftzone,0,1);
	if (	$sub != "-"
		and $sub != "+"
		and $sub != " "
		and $ftzone != 0
		) {
		$ftzone = "+".$ftzone;
	}

	$print_pin_error = "";
	if ($err > 0 and $err != 12) {
		$print_pin_error .= "<b>ERROR: ";
		$print_pin_error .= (key_exists($err,$errors)) ? $errors[$err] : "Unknown error (undefined)" ;
		$print_pin_error .= "</b><br /><br />\n";
	}
?>
<template>
	<onevent type="onenterforward">
		<refresh>
			<setvar name='pin' value='' />
		</refresh>
	</onevent>
	<onevent type="onenterbackward">
		<refresh>
			<setvar name='pin' value='' />
		</refresh>
	</onevent>
</template>
<card title="GM <? echo $fuser?>">
<p align="center">
	<big>
	<b>gmail-mobile</b><br />
	</big>
	<small>
	<b>PIN Sign-In</b><br />
	<br />
	Bookmark this page for PIN Sign-in<br />
	<br />
 	<a href="index.php?u=<? echo $fuser ?>&amp;up=0&amp;tz=<? echo $ftzone ?>">Use Standard Sign-in</a><br />
	</small>
	<br />
</p>
<p>
	<? echo $print_pin_error; 
	if ($err != 18 and $err != 19 and $err != 50) {?>
	Username: <? echo $fuser ?><br />
	Time zone: <? echo $ftzone ?><br />
	PIN: 
	<input name="pin" type="password" title="PIN:(4-10 numbers)" format="NNNN*N" maxlength="10" emptyok="true" /><br />
	<b>
    <anchor title="PIN Sign in"><go href="index.php" method="post">	
    <postfield name="user" value="<? echo $fuser ?>" />
    <postfield name="pin" value="$(pin)" />
	<postfield name="signin" value="si" />
	<postfield name="up" value="1" />
    </go>Sign in</anchor></b><br />
    <br />
    <? 
	// retrieve latest gmail-mobile news
	display_news();
    }
 ?>
</p>
<p align="center">
<br />
<small><a href="disclaim.php">Disclaimer</a><br />
<br />
<? /* The following message cannot be removed.  See License */ ?>
<!-- Next lines cannot be removed. See License -->
Powered by:<br />
gmail-mobile <? echo GMOB_VER ?>
</small>
</p>
<?
    print_footer();
	exit;
} elseif ($conf['use_pin'] and $use_pin and !$pin_user_found) {
	$err = 33;

}
// end if ($pin_user_found)

?>
<template>
<onevent type="onenterforward">
<refresh>
<? 
if (($logout) or ($err > 0 and $err != 33)) {
	echo "<setvar name='pass' value='' />\n";
	echo "<setvar name='timezone' value='".str_replace(" ","+","$timezone")."' />\n";
	if ($conf['use_pin']) echo "<setvar name='newpin' value='' />\n";
} else {
	echo "<setvar name='user' value='".(($fuser != "")?$fuser:$user)."' />\n";
	echo "<setvar name='pass' value='' />\n";
	echo "<setvar name='timezone' value='".str_replace(" ","+","$timezone")."' />\n";
	if ($conf['use_pin']) echo "<setvar name='newpin' value='' />\n";
} ?>
</refresh>
</onevent>
<onevent type="onenterbackward">
<refresh>
<setvar name="pass" value='' />
<?	if ($conf['use_pin']) echo "<setvar name='newpin' value='' />\n"; ?>
</refresh>
</onevent>
</template>
<?
if ($logout) {
	echo '<card title="gmail-mobile" newcontext="true">';
} else {
	echo '<card title="gmail-mobile">';
}
?>
<p align="center">
<big><b>gmail-mobile</b></big>
<small><br />
Check Gmail with (almost) any mobile on planet Earth, since Sept 2004.<br /><br />
<b>gmail-mobile is NOT an official Gmail or Googlemail service.</b><br />
</small>
<br />
</p>
<p>
<?
	if ($err > 0 and $err != 12) {
		echo "<b>ERROR: ";
		echo (key_exists($err,$errors)) ? $errors[$err] : "Unknown error (undefined)" ;
		echo "</b><br /><br />\n";
	}

	if ($err != 12) {
		if ($err != 18 and $err != 19 and $err != 50) {
		if ($signin_message_top != "") echo $signin_message_top."<br /><br />\n";
	?>
Username:<br />
<input name="user" type="text" title='Username:' format="*m" emptyok="true" />
<? if ($conf['use_pin']) { ?>

<small><a href="index.php?user=$(user)&amp;up=1">PIN Sign-in</a></small><br />
<? /*
<small><anchor title="PIN Sign-in"><go href="index.php?user=$(user)" method="get">
</go>PIN Sign-in</anchor></small><br />
*/ ?>
	<? 
	}
	?>
<br />
Password:<br />
<small><b>Visible, to aid entry</b><br /></small>
<input name="pass" type="text" title="Password: (Case SeNsiTivE)" format="m*m" emptyok="true" /><br />
	<?	}
	} else {
		echo $errors[10]."<br /><br />\n";
		echo "<b>Gmail has requested login verification, which cannot be done through gmail-mobile yet.  You must sign in through the website before you can sign in from here.</b>  This MAY be due to too many incorrect attempts or Gmail thinks your password is too easy to guess, so change your password.<br />\n";
	}
	
	if ($err == 12) {
/* 		echo $errors[10]."<br /><br />\n"; */
/* 		echo "Enter the correct password above and then type the characters you see in the picture below.<br />\n"; */
		?>
<? //		<img src="index.php?log_png=1&amp;username=<? echo $username ? >&amp;token=<? echo urlencode($login_token) ? >&amp;<? echo basename(SID); ? >" alt="[Graphic]" /><br />
//		<input name="log_chal" type="text" title="Characters in graphic: (NOT case-sensitive)" format="*m" emptyok="false" />
?>		<?
/* 		echo "<br />Enter the letters as they are shown in the image above.<br />\n"; */
	}
	
	if ($err != 12) {
		if ($err != 18 and $err != 19 and $err != 50) {
	?>
Timezone:<br />
<select name="timezone" title="Timezone">
	<?
	foreach ($time_zones as $indexval => $value) {
		echo "<option value=\"$value\">$value</option>\n";
	}
	?>
</select>
<? if ($conf['use_pin']) { ?>
<br />Create Sign-in PIN: <small><a href="pin.php">What is this?</a><br />
(NOT required)</small><br />
<input name='newpin' type='password' title='Create PIN: (not required)' maxlength='10' format='NNNN*N' emptyok='true' /><br />
<? } ?>
<br />
<b>
<anchor title="Sign in"><go href="index.php?&amp;zr=<? echo str_rand(6); ?>" method="post">
<postfield name="user" value="$(user)" />
<postfield name="pass" value="$(pass)" />
<postfield name="timezone" value="$(timezone)" />
<postfield name="signin" value="si" />
<?		if ($conf['use_pin']) { ?>
<postfield name="newpin" value="$(newpin)" />
<?		}
		if ($err == 12) { ?>
<postfield name="logintoken" value="<? echo $login_token ?>" />
<postfield name="logincaptcha" value="$(log_chal)" />
<postfield name="<? echo session_name(); ?>" value="<? echo session_id(); ?>" />
		<? } ?>
</go>Sign in</anchor>
</b><br />
<? 		}
	}
	echo "<br />";
	echo $signin_message_bottom; 
	echo "<br /><br />\n";

	// retrieve latest gmail-mobile news
	display_news();

	?>
</p>
<p align="center">
<small><a href="disclaim.php">Disclaimer</a><br />
<br />
<? /* The following message cannot be removed.  See License */ ?>
<!-- Next lines cannot be removed. See License -->
Powered by:<br />
gmail-mobile <? echo GMOB_VER ?>
</small>
</p>
<?
print_footer();

exit;

//
// Functions
//


function pin_edit($user,$action,$string = "") {
	global $pin_filename;
	global $div;
	global $pin_field;
	global $expire_time;

	if (($action == "replace")  or ($action == "delete")) {
		if (!($all_user_lines = file("$pin_filename"))) {
			return false;
		}

		$new_user_lines = "";
		$pin_count 		= count($all_user_lines);
		
		for($i = 0; $i < $pin_count; $i++) {
			$user_data = explode(" ",$all_user_lines[$i]);
			// invalid PIN format, skip (delete)
			if ( 	(count($user_data) != ($pin_field+2+1))
				 or (!isset($user_data[0]))
				 or (!isset($user_data[1]))
				 or ($user_data[0] != '<?') 
				 or ($user_data[1] != '/*')
				) continue;

			// expire old PINs
			if ($user_data[2] < $expire_time) continue;

			@list ($cryptuser, $junk) = split($div, base64_decode(trim($user_data[$pin_field])));
			if (($cryptuser != "") and (crypt($user,$cryptuser) != $cryptuser)) {
				$new_user_lines .= $all_user_lines[$i];
			}
		}
		
		if ($action == "replace") {
			$new_user_lines .= "<? /* ".$string." *"."/ ?".">\n";
		} 
	
		$fd = fopen("$pin_filename", "w");
		fwrite($fd, $new_user_lines);
		fclose($fd);
		
	} elseif ($action == "add") {
		$fd = fopen("$pin_filename", "a");
		fwrite($fd, "<? /* ".$string." *"."/ ?".">\n");
		fclose($fd);
		
	}
}


//
//  Class to retrieve remote file if allow_url_fopen is OFF
//  Copyright (c) 2005 by Patrick Schlangen <info AT b1g DOT de>
//

//#usage:
//$r = new HTTPRequest('http://www.php.net');
//echo $r->DownloadToString();

class HTTPRequest {
	var $_fp;		// HTTP socket
	var $_url;		// full URL
	var $_host;		// HTTP host
	var $_protocol;	// protocol (HTTP/HTTPS)
	var $_uri;		// request URI
	var $_port;		// port

	// scan url
	function _scan_url() {
		$req = $this->_url;

		$pos = strpos($req, '://');
		$this->_protocol = strtolower(substr($req, 0, $pos));
	  
		$req = substr($req, $pos+3);
		$pos = strpos($req, '/');
		if($pos === false)
			$pos = strlen($req);
		$host = substr($req, 0, $pos);

		if(strpos($host, ':') !== false) {
			list($this->_host, $this->_port) = explode(':', $host);
		} else {
			$this->_host = $host;
			$this->_port = ($this->_protocol == 'https') ? 443 : 80;
		}
	  
		$this->_uri = substr($req, $pos);
		if($this->_uri == '')
			$this->_uri = '/';
   }
  
	// constructor
	function HTTPRequest($url) {
		$this->_url = $url;
		$this->_scan_url();
	}
  
	// download URL to string
	function DownloadToString() {
		$crlf = "\r\n";
		
		// generate request
		$req = 'GET ' . $this->_uri . ' HTTP/1.0' . $crlf
		.	'Host: ' . $this->_host . $crlf
		.	$crlf;
		
		// fetch
		$this->_fp = fsockopen(($this->_protocol == 'https' ? 'ssl://' : '') . $this->_host, $this->_port);
		fwrite($this->_fp, $req);
		while(is_resource($this->_fp) && $this->_fp && !feof($this->_fp)) {
			$response .= fread($this->_fp, 1024);
		}
		fclose($this->_fp);
		
		// split header and body
		$pos = strpos($response, $crlf . $crlf);
		if($pos === false) return($response);
		$header = substr($response, 0, $pos);
		$body = substr($response, $pos + 2 * strlen($crlf));
		
		// parse headers
		$headers = array();
		$lines = explode($crlf, $header);
		foreach($lines as $line) {
			if(($pos = strpos($line, ':')) !== false)
				$headers[strtolower(trim(substr($line, 0, $pos)))] = trim(substr($line, $pos+1));
		}
		
		// redirection?
		if(isset($headers['location'])) {
			$http = new HTTPRequest($headers['location']);
			return($http->DownloadToString($http));
		} else {
			return($body);
		}
	}
}

//
// retrieve latest gmail-mobile news
//
function display_news() {
	
	$until = time() - 1209600;
	$string = "";
	$announce = array();
	
	if ((bool) ini_get('allow_url_fopen')) {
		// if allow_url_fopen = On
		if ($announce = file('http://gmobile.sayni.net/gmobile_news.txt')) {
			// nothing!  success!
		} else {
			$string = "News retrieval error.<br />";
		}
	} else {
		// if allow_url_fopen = Off
		$r = new HTTPRequest('http://gmobile.sayni.net/gmobile_news.txt');
		$announce = explode("\n",$r->DownloadToString());
	}
	
	if ($string == "") {
		$count_announce = count($announce);
		for ($i = 0; $i < $count_announce ; $i++) {
			$line = trim($announce[$i]);
			if ($line == "") continue;
			if ($line == "*.*.*") break;
			list($time,$date,$message) = @explode(";;",$line);
			if ($time > $until) $string .= $date.": ".$message."<br />\n";
		}
		if ($string == "") $string = "No news for past 14 days.<br />";
	}

	if ($string != "") $string = "<small><u><b>Latest gmail-mobile News:</b></u><br />\n".trim($string)."</small><br />";
	echo $string;

}
?>