<?
/****************************************************************

gmail-mobile (a.k.a. unofficial Gmail Mobile)
Copyright (c) 2005, 2006
Neerav Modi and others

Version 0.11 (c) 2004
GAN Ying Hung, Rudi Pittman, Gaston Annebicque

Licensed under the GNU GPL. For full terms see the file COPYING.

gmail-mobile (unofficial Gmail Mobile since Sept 2004) provides
access to Gmail accounts with any WAP enabled phone or hand held
(in WML format).

http://gmail-mobile.sourceforge.net

*****************************************************************/

require_once("libgmailer.php");
require_once("config.php");

// create the gmail object
$gmailer = new GMailer();
// initialize connection
quick_init($gmailer);

// Connect to gmail
connect_gmail();

// Localization (l10n) phrases
load_language();

$th 	= (isset($_REQUEST['th'])) 		? $_REQUEST['th'] 		: 0;
$mg 	= (isset($_REQUEST['mg'])) 		? $_REQUEST['mg'] 		: 0;
$std 	= (isset($_REQUEST['std'])) 	? $_REQUEST['std'] 		: 0;
$label 	= (isset($_REQUEST['label'])) 	? $_REQUEST['label'] 	: "";
$sum	= (isset($_REQUEST['sum']))		? $_REQUEST['sum'] 		: 0; 	// boolean
$inbox	= (isset($_REQUEST['inbox']))	? $_REQUEST['inbox'] 	: 0; 	// boolean
$unread = (isset($_REQUEST['unread'])) 	? $_REQUEST['unread'] 	: 0;	// boolean
$query 	= (isset($_REQUEST['query'])) 	? $_REQUEST['query'] 	: false;// boolean
$msg_part = (isset($_GET['msg_part']))	? $_GET['msg_part'] 	: 1;
$start_msg = (isset($_GET['mst']))		? $_GET['mst'] 			: 0;
$unlabeled = (isset($_REQUEST['unlab'])) ? $_REQUEST['unlab'] 	: 0;	// boolean
$quoted_show = 
		 (isset($_REQUEST['quote_show'])) ? $_REQUEST['quote_show'] : false;
$clear_history = (isset($_REQUEST['clrh']))	? $_REQUEST['clrh'] : false;

$dis_older_ths = 5;
$pos 	= (isset($_REQUEST['pos'])) 	
			? $_REQUEST['pos'] 		
			: ((isset($_SESSION['gm_last_position'])) 
				? $_SESSION['gm_last_position']
				: 0
			  )
			;

//
// Variables for doing an action (label, delete, spam, unread, etc)
//
$act	= (isset($_REQUEST['act']))		? $_REQUEST['act']		: 0;
$lbl	= (isset($_REQUEST['lbl']))		? $_REQUEST['lbl']		: "";

// Add sender to Contacts list
$astc	= (isset($_REQUEST['astc']))	? $_REQUEST['astc']		: 0;

// Star it, unstar it
$starit	= (isset($_REQUEST['st']))		? $_REQUEST['st']		: -1;

// formally called $t
$msgs 	= (isset($_REQUEST['msgs']))	? $_REQUEST['msgs'] 	: array();
$back 	= (isset($_REQUEST['back']))	? $_REQUEST['back'] 	: basename(SELF);

// act on multiple messages
$mact	= (isset($_REQUEST['mact']))	? $_REQUEST['mact']		: 0;


//
// Adjustments for small memory/pagesize phones
//
if (!(isset($_SESSION['gm_msg_per_page']))) {
	$_SESSION['gm_msg_per_page'] = $conf['num_msgs'];
	$_SESSION['gm_page_size'] 	 = "m";
	$_SESSION['gm_links_display'] = $conf['links_display'];
	$_SESSION['gm_msg_dis_length'] = $conf['display_msg_length'];
	$_SESSION['gm_no_transform'] = 0;
}
if (!(isset($_SESSION['gm_no_transform']))) {
	$_SESSION['gm_no_transform'] = 0;
}
$dis_older_ths = ($_SESSION['gm_msg_per_page'] < $conf['num_msgs']) ? 2 : 5;

$status = false;
$status_message = "";

$stdbox = GMailer::getStandardBox();	

/* if (isset($_REQUEST['showlabels'])) { */
/* 	$_SESSION['gm_show_labels'] = $_REQUEST['showlabels']; */
/* } elseif (!isset($_SESSION['gm_show_labels'])) { */
/* 	$_SESSION['gm_show_labels'] = false; */
/* } */

//
// Perform message action
//

if (	(($act > 0) or ($lbl != ""))	// if an action is defined
			and 
		((count($msgs) > 0)	or ($mact))	// and message number(s) supplied
	) {
	
	$temp_lastbox = ($_SESSION['gm_last_box_name'] == "_unlabeled" or $_SESSION['gm_last_box_name'] == "_unread")
		?  ""
		:  $_SESSION['gm_last_box_name']
		;	

	if ($lbl != "") {
		if ($mact) {
			$msgs = $_SESSION['gm_selected_msgs'];
		}
		$labels = explode (";",str_replace(")","",$lbl));
		$my_labels_remove = array();
		$my_labels_apply = array();
		$my_status 		= "";
		$my_removed 	= 0;
		$my_apply 		= 0;
		foreach ($labels as $indexval => $label_number) {
			if (substr($label_number,0,1) == "-") {
				// remove label
				$action = 2;
				$my_labels_remove[] = $_SESSION['gm_all_labels'][(int)abs((int)$label_number)];
				$my_removed++;
			} else {
				// apply label
				$action = 1;
				if (!isset($_SESSION['gm_all_labels'][(int)abs((int)$label_number)])) {
					//debug_print(basename(__FILE__)." ".__LINE__.": label (".$label_number.".) doesn't exist, dump all labels".print_r($_SESSION['gm_all_labels'],true));
				}
				$my_labels_apply[] = $_SESSION['gm_all_labels'][(int)abs((int)$label_number)];
				$my_apply++;
			}
			// converts numeric label into text AND url encodes it
			$full_label_name = addslashes(urlencode($_SESSION['gm_all_labels'][(int)abs((int)$label_number)]));

			// perform the action
			$status = $gmailer->performAction($action, $msgs, $full_label_name, $temp_lastbox);
		}

		$my_labels_remove = implode(", ",$my_labels_remove);
		$my_labels_apply  = implode(", ",$my_labels_apply);
		$plural1 = ($my_removed == 1) ? "" : "s" ;
		$plural2 = ($my_removed == 1) ? "has" : "have" ;
		$plural1c = (is_array($msgs) and count($msgs) == 1) ? "The conversation" : count($msgs)." conversations" ;
		$plural2c = (is_array($msgs) and count($msgs) == 1) ? "has" : "have" ;
		
		if (($my_apply == 0) and ($my_removed == 0)) {
			$my_status .= $gm_lang['no_conv_selected'];
		} else {
			if ($my_apply > 0)   $my_status .= $plural1c." ".$plural2c." been labeled \"$my_labels_apply\". ";
			if ($my_removed > 0) $my_status .= "The label".$plural1." \"$my_labels_remove\" ".$plural2." been removed from ".strtolower($plural1c).". ";
		}
		$status = true;
		$status_message = cleanse_string($my_status,true);

	} else {
		if ($mact) {
			$msgs = $_SESSION['gm_selected_msgs'];
		}
		// perform the action
		$status = $gmailer->performAction($act, $msgs, $lbl, $temp_lastbox);
		$status_message	= $gmailer->lastActionStatus('message');
		$status_message = str_replace($gm_lang['learn_more'],"",sanitize_body($status_message));
		
		//clear_message_cache();
	}


	// decode $back in preparation for redirection
	$back = code_url($back,"decode");

	// redirect
	$title = $gm_lang['applying_action'];
	$message = "<b>$status_message</b>";
	

	// actual redirection
	redirect_page("$back", $title, $message);	

	// MUST exit script after redirecting
 	exit();
}

//
// perform action on multiple messages of mailbox
//
elseif ($mact) {				
	$_SESSION['gm_selected_msgs'] = array();
	if (isset($_REQUEST['m_ids']) and isset($_REQUEST['m_vals'])) {
		$ids 	= explode(";",$_REQUEST['m_ids']);
		$values = explode(";",str_replace(")","",$_REQUEST['m_vals']));
	
		$count_ids = count($ids);
		for ($i=0 ; $i < $count_ids; $i++) {
			if (isset($values[$i]) and $values[$i] == 1) {
				$_SESSION['gm_selected_msgs'][] = $ids[$i];
			}
		}
	}
	
	//debug_print("selected messages: ".print_r($_SESSION['gm_selected_msgs'],true));
	//debug_print("cached message: ".print_r($_SESSION['gm_box_cache'],true));

	$mul_is_starred = false;
	$mul_is_unstarred = false;
	$mul_is_read = false;
	$mul_is_unread = false;

	$total_cached_box = count($_SESSION['gm_box_cache']);
	for ($i=0 ; $i < $total_cached_box; $i++) {
		if (in_array($_SESSION['gm_box_cache'][$i]['id'],$_SESSION['gm_selected_msgs'])) {
			$this_message = $_SESSION['gm_box_cache'][$i];
			if ($this_message['is_starred']) {
				$mul_is_starred = true;
			} else {
				$mul_is_unstarred = true;
			}
			if ($this_message['is_read']) {
				$mul_is_unread = true;
			} else {
				$mul_is_read = true;
			}
		}
	}


	print_headers();			// send wml headers
	include("template.php");	// print template

	echo "<card title='".$gm_lang['conv_actions']."'>\n";
	echo "<onevent type='onenterforward'>\n";
	echo "<refresh>\n";
	echo "<setvar name='act' value='0' />\n";
	echo "<setvar name='label' value='' />\n";
	echo "</refresh>\n";
	echo "</onevent>\n";
	echo "<p>\n";
	
	// display a system-wide message
	system_message();	

	echo "<b>".$gm_lang['conv_actions_cap']."</b><br /><br />\n";
	
	echo $gm_lang['choose_act4conv']."<br /><br />\n";

	//////////////////////////
	//
	// message action menu
	//
	echo $gm_lang['choose_action_elip']."<br />";
	echo "<select name=\"act\" value=\"0\">\n";
	echo "<option value=\"0\">-".$gm_lang['choose_action']."-</option>\n";

	// 10 delete forever.  Can/should it be used for conversations?
	// 15 trash msg.  not used for conversations

	if (	($_SESSION['gm_last_box_name'] != "trash")
				and
			($_SESSION['gm_last_box_name'] != "spam")
		) {
		echo "<option value=\"".GM_ACT_ARCHIVE."\">".$gm_lang['archive']."</option>\n";
	}
	if (($_SESSION['gm_last_box'] == "std") and ($_SESSION['gm_last_box_name'] == "trash")) {
		// "move to inbox" is misleading.  Its meaning is "untrash".	
		echo "<option value=\"".GM_ACT_UNTRASH."\">".$gm_lang['move_to_inbox']."</option>\n";
	} elseif (($_SESSION['gm_last_box'] == "std") and ($_SESSION['gm_last_box_name'] == "spam")) {
		echo "<option value=\"".GM_ACT_UNSPAM."\">".$gm_lang['not_spam']."</option>\n";
	} elseif (($_SESSION['gm_last_box'] != "std") or ($_SESSION['gm_last_box_name'] != "inbox")) {
		echo "<option value=\"".GM_ACT_INBOX."\">".$gm_lang['move_to_inbox']."</option>\n";
	}

	if ($mul_is_unread) echo "<option value=\"".GM_ACT_READ."\">".$gm_lang['mark_read']."</option>\n";
	if ($mul_is_read) echo "<option value=\"".GM_ACT_UNREAD."\">".$gm_lang['mark_unread']."</option>\n";

	if (($_SESSION['gm_last_box'] != "std") or ($_SESSION['gm_last_box_name'] != "starred")) {
		if ($mul_is_unstarred) echo "<option value=\"".GM_ACT_STAR."\">".$gm_lang['star']."</option>\n";
	}
	if ($mul_is_starred) echo "<option value=\"".GM_ACT_UNSTAR."\">".$gm_lang['remove_star']."</option>\n";

	if ($_SESSION['gm_last_box_name'] != "spam") {
		echo "<option value=\"".GM_ACT_SPAM."\">".$gm_lang['report_spam']."</option>\n";
	}

	if (($_SESSION['gm_last_box'] == "std") and ($_SESSION['gm_last_box_name'] == "drafts")) {
		echo "<option value=\"".GM_ACT_UNDRAFT."\">".$gm_lang['discard_drafts']."</option>\n";
	} elseif (($_SESSION['gm_last_box'] == "std") and ($_SESSION['gm_last_box_name'] == "trash")) {
		echo "<option value=\"".GM_ACT_DELTRASHED."\">".$gm_lang['delete_forever']."</option>\n";
	} elseif (($_SESSION['gm_last_box'] == "std") and ($_SESSION['gm_last_box_name'] == "spam")) {
		echo "<option value=\"".GM_ACT_DELSPAM."\">".$gm_lang['delete_forever']."</option>\n";
	} else {
		echo "<option value=\"".GM_ACT_TRASH."\">".$gm_lang['move_to_trash']."</option>\n";
	}
	
	echo "</select><br />\n";
	//
	//////////////////////////
	
	echo "<b>".$gm_lang['or']."</b><br />\n";

	//////////////////////////
	//
	// label menu
	//
	$remove_label = "";
	$apply_label = "";
	$selected_labels = array();
	$box_count = count($_SESSION['gm_box_cache']);
	
	for ($i = 0; $i < $box_count; $i++) {
		if (array_search($_SESSION['gm_box_cache'][$i]['id'], $_SESSION['gm_selected_msgs']) !== false) {
			$count_cache_labels = count($_SESSION['gm_box_cache'][$i]['labels']);
			for ($j = 0; $j < $count_cache_labels; $j++) {
				$selected_labels[] = $_SESSION['gm_box_cache'][$i]['labels'][$j];
			}
		}
	}

	echo $gm_lang['app_rem_label']." \n";
	echo "<small>\n";
	echo $gm_lang['multiple_at_once'];
	echo "<anchor>".$gm_lang['reset']."<refresh>\n";
	echo "<setvar name=\"label\" value=\"\" />\n";
	echo "</refresh></anchor>\n";
	echo "</small><br />\n";

	if (count($_SESSION['gm_all_labels']) > 0) {
		reset($_SESSION['gm_all_labels']);
		foreach ($_SESSION['gm_all_labels'] as $indexval => $label_name) {
			$apply_label .= "<option value=\"".$indexval."\">+".cleanse_string($label_name)."</option>\n";
			if (array_search($label_name, $selected_labels) !== false) {
				$remove_label .= "<option value=\"-".$indexval."\">-".cleanse_string($label_name)."</option>\n";
			}
		}
	
		echo '<select title="'.$gm_lang['labels_col'].'" name="label" multiple="true">'."\n";
		if ($apply_label != "") {
			echo "<optgroup title=\"".$gm_lang['apply_label']."\">\n";
			echo $apply_label;
			echo "</optgroup>\n";
		}
		if ($remove_label != "") {
			echo "<optgroup title=\"".$gm_lang['remove_label']."\">\n";
			echo $remove_label;
			echo "</optgroup>\n";
		}
		echo "</select>\n";
	} else {
		echo $gm_lang['have_no_labels']."<br />\n";
	}

	//
	//////////////////////////

	//////////////////////////
	// 
	// Post action
	//
	echo "<big><b><anchor>".$gm_lang['go']."<go href=\"main.php?mact=1&amp;".strip_tags(SID)."\" method=\"post\">\n";
	echo "<postfield name=\"act\" value=\"$(act)\" />\n";
	echo "<postfield name=\"lbl\" value=\"$(label)\" />\n";
	echo "</go></anchor></b></big>\n";
	//
	//////////////////////////
	
	echo "</p>\n";
	echo "</card>\n";
	echo "</wml>";
	exit;

} elseif ($astc) {
	$gmailer->addSenderToContact($mg);
	$status_message = $gm_lang['sender_added_cnts'];
} elseif ($starit == 0) {
	$mess_num = ($_SESSION['gm_last_message']) ? $_SESSION['gm_last_message'] : $_SESSION['gm_last_thread'];
	$th = $_SESSION['gm_last_thread'];
	$mg = $_SESSION['gm_last_message'];
	if ($gmailer->starMessageQuick($mess_num,"unstar")) {
		$_SESSION['gm_msg_cache_id'] = "";
		$_SESSION['gm_thread_cache_id'] = "";
	}
	//$status_message = $gm_lang['sender_added_cnts'];
} elseif ($starit == 1) {
	$mess_num = ($_SESSION['gm_last_message']) ? $_SESSION['gm_last_message'] : $_SESSION['gm_last_thread'];
	$th = $_SESSION['gm_last_thread'];
	$mg = $_SESSION['gm_last_message'];
	if ($gmailer->starMessageQuick($mess_num,"star")) {
		$_SESSION['gm_msg_cache_id'] = "";
		$_SESSION['gm_thread_cache_id'] = "";
	}
	//$status_message = $gm_lang['sender_added_cnts'];
}

//////////////////////////
//
// create queries
//

// for some strange reason, this session variable isn't always defined.  why??
if (!isset($_SESSION['gm_last_box'])) $_SESSION['gm_last_box'] = "login";

if ($th) {
	// conversation thread or message
	$title = $gm_lang['conversation'];
	if ($_SESSION['gm_last_box'] != "std") {
		$std = "inbox";
	} else {
		$std = $_SESSION['gm_last_box_name'];
	}

	$_SESSION['gm_last_thread'] = $th;

	if ($mg) {
/* 		// see if message exists in thread, else retrieve new thread. */
/* 		if (!isset($_SESSION['gm_thread_index_cache']["$mg"])) { */
/* 			$_SESSION['gm_msg_cache_id'] = ""; */
/* 			$q = "search=".$std."&view=cv&th=".$th; */
/* 			$_SESSION['gm_last_message'] = $th; */
/* 			$mg = 0; */
/* 		} */
		$q = "search=".$std."&view=cv&th=".$th."&msgs=".$mg;
		$_SESSION['gm_last_message'] = $mg;
	} else {
		$q = "search=".$std."&view=cv&th=".$th;
		$_SESSION['gm_last_message'] = $th;
	}
	
} elseif ($sum) {
	// summary view
	$q = "search=cat&cat=dummyjusttoretrievesummary&view=tl&start=0&init=1";
	$title = $gm_lang['summary'];
	$_SESSION['gm_search_query']  = "";	// reset search query
	$_SESSION['gm_last_position'] = 0;	// reset message position
	$_SESSION['gm_last_box'] 	  = "summary";
	$_SESSION['gm_last_box_name'] = "";
	$_SESSION['gm_backto'] 		  = $gm_lang['summary'];
	clear_message_cache();

} elseif ($inbox) {
	// Standard box
	$std = "inbox";
	$q = "search=".$std."&view=tl&start=".$pos;
	$title = $gm_lang['std_box_name'][array_search(ucfirst($std),$stdbox)];
	$_SESSION['gm_search_query']  = ""; // reset search query
	$_SESSION['gm_last_box'] 	  = "std";
	$_SESSION['gm_last_box_name'] = $std;
	$_SESSION['gm_last_position'] = $pos;
	$_SESSION['gm_backto'] 		  = $gm_lang['std_box_name'][array_search(ucfirst($std),$stdbox)];
	clear_message_cache();

} elseif (($unread) or ($_SESSION['gm_last_box'] == "search" and $_SESSION['gm_last_box_name'] == "_unread")) {
	// unread
	$q = "search=query&q=is%3Aunread&view=tl&start=".$pos;
	$title = $gm_lang['unread'];
	$_SESSION['gm_search_query']  = "is:unread"; // set search query
	$_SESSION['gm_last_position'] = $pos;
	$_SESSION['gm_last_box'] 	  = "search";
	$_SESSION['gm_last_box_name'] = "_unread";
	$_SESSION['gm_backto'] 		  = $gm_lang['unread'];
	clear_message_cache();
	$unread = true;
	
} elseif ($unlabeled or ($_SESSION['gm_last_box'] == "search" and $_SESSION['gm_last_box_name'] == "_unlabeled")) {
	// unlabeled
	$query = "";
	$total_labels = count($_SESSION['gm_all_labels']);
	for ($lab = 0; $lab < $total_labels; $lab++) {
		$query .= "-label:".strtolower(str_replace(" ","-",$_SESSION['gm_all_labels'][$lab]))." ";
	}
	//echo $query;

	$q = "search=query&q=".urlencode($query)."&view=tl&start=".$pos;
	$title = $gm_lang['unlabeled'];
	$_SESSION['gm_search_query']  = $query; // set search query
	$_SESSION['gm_last_position'] = $pos;
	$_SESSION['gm_last_box'] 	  = "search";
	$_SESSION['gm_last_box_name'] = "_unlabeled";
	$_SESSION['gm_backto'] 		  = $gm_lang['unlabeled'];
	clear_message_cache();
	$unlabeled = true;
	
} elseif (($query) or ($_SESSION['gm_last_box'] == "search" and $_SESSION['gm_search_query'] != "is:unread")) {
	// search results
	$q = "search=query&q=".urlencode($_SESSION['gm_search_query'])."&view=tl&start=".$pos;
	$title = $gm_lang['search_results'];
	$_SESSION['gm_last_box'] 	  = "search";
	$_SESSION['gm_last_box_name'] = "";
	$_SESSION['gm_last_position'] = $pos;
	$_SESSION['gm_backto'] 		  = $gm_lang['search_results'];
	clear_message_cache();
	$query = true;

} elseif (($label != "") or ($_SESSION['gm_last_box'] == "label")) {
	// Label box
	$label_name = ($label != "") 
		? $_SESSION['gm_all_labels'][$label]
		: $_SESSION['gm_last_box_name']
		;
	$q = "search=cat&cat=".urlencode($label_name)."&view=tl&start=".$pos;
	$title = cleanse_string($label_name);
	$_SESSION['gm_last_position'] = $pos;
	$_SESSION['gm_search_query']  = ""; // reset search query
	$_SESSION['gm_last_box'] 	  = "label";
	$_SESSION['gm_last_box_name'] = $label_name;
	$_SESSION['gm_backto'] 		  = cleanse_string('"'.$label_name.'"');
	clear_message_cache();

} elseif ($std or $_SESSION['gm_last_box'] == "std") {
	// Standard box
	if (!$std) $std = $_SESSION['gm_last_box_name'];
	$q = "search=".$std."&view=tl&start=".$pos;
	$title = $gm_lang['std_box_name'][array_search(ucfirst($std),$stdbox)];
	$_SESSION['gm_search_query']  = ""; // reset search query
	$_SESSION['gm_last_box'] 	  = "std";
	$_SESSION['gm_last_box_name'] = $std;
	$_SESSION['gm_last_position'] = $pos;
	$_SESSION['gm_backto'] 		  = $gm_lang['std_box_name'][array_search(ucfirst($std),$stdbox)];
	clear_message_cache();

} elseif (($_SESSION['gm_last_box'] == "summary")) {
	// summary view
	$q = "search=cat&cat=dummyjusttoretrievesummary&view=tl&start=0&init=1";
	$title = $gm_lang['summary'];
	$_SESSION['gm_search_query']  = "";	// reset search query
	$_SESSION['gm_last_position'] = 0;	// reset message position
	$_SESSION['gm_last_box'] 	  = "summary";
	$_SESSION['gm_last_box_name'] = "";
	$_SESSION['gm_backto'] 		  = $gm_lang['summary'];
	clear_message_cache();
	$sum = true;

} else {
	// if nothing else, inbox
	$q = "search=inbox&view=tl&start=0&init=1";
	$std = "inbox";
	$title = $gm_lang['std_box_name'][0];
	$_SESSION['gm_search_query']  = ""; // reset search query
	$_SESSION['gm_last_box'] 	  = "std";
	$_SESSION['gm_last_box_name'] = "inbox";
	$_SESSION['gm_last_position'] = 0;
	$_SESSION['gm_backto'] 		  = $gm_lang['std_box_name'][0];
	clear_message_cache();
	
}
//
//////////////////////////
																																						 
//////////////////////////
//
// retrieve query/messages
//
$msg_is_draft = false;
if (!$sum and ($th || $mg)) {
	if ($mg /* and isset($_SESSION['gm_thread_index_cache']["$mg"]) */) {
		//debug_print("message id specified, just printing thread:".print_r($_SESSION['gm_thread_cache'],true));

		// see if message exists in thread, else retrieve new thread.
		if (!isset($_SESSION['gm_thread_index_cache']["$mg"])) {
			// msg not found, redirect to last mailbox
			//debug_print(basename(__FILE__).": ".__LINE__.", message not found in thread: wanted ".$mg."\n".print_r($_SESSION['gm_thread_index_cache'],true));
			//debug_print(basename(__FILE__).": ".__LINE__.", dumping thread (from above error)".print_r($_SESSION['gm_thread_cache'],true));
			msg_not_found("Message not found.  Please report to the developer at gmobile@sayni.net to help improve gmail-mobile.");
		}

		// requesting part x of a message
		// retrieve from cache

		// see if the message is a draft
		$msg_index_in_thread = $_SESSION['gm_thread_index_cache']["$mg"];
		//debug_print("extracted conv from thread:".print_r($_SESSION['gm_thread_cache']->conv[$msg_index_in_thread],true));
		if ($_SESSION['gm_thread_cache']->conv[$msg_index_in_thread]['is_draft']) {
			$msg_is_draft = true;
		}

		if ($msg_is_draft) {
			// retrieve the message from the THREAD
			$snapshot = $_SESSION['gm_thread_cache'];
			$_SESSION['gm_msg_cache'] = $snapshot;
			$_SESSION['gm_msg_cache_id'] = $mg;
		
		} elseif (isset($_SESSION['gm_msg_cache_id']) and $mg == $_SESSION['gm_msg_cache_id']) {
			$snapshot = $_SESSION['gm_msg_cache'];
			//debug_print("used message from cache");
		} else {
			// retrieve from Gmail
			$gmailer->fetch($q);
			$snapshot = $gmailer->getSnapshot(GM_STANDARD|GM_LABEL|GM_QUERY|GM_CONVERSATION);
			//debug_print("retrieved message: ".print_r($snapshot,true));
			//debug_print("message not in cache, retrieved from gmail");
			if ($snapshot->created == 0) static_error($snapshot->snapshot_error);
			$_SESSION['gm_msg_cache'] = $snapshot;
			$_SESSION['gm_msg_cache_id'] = $mg;
		}
		// retrieve thread index from cache
		$thread_index = $_SESSION['gm_thread_index_cache'];
	} else {
	
		// requesting thread
		if (isset($_SESSION['gm_thread_cache_id']) and $th == $_SESSION['gm_thread_cache_id']) {
			// retrieve from cache
			$snapshot = $_SESSION['gm_thread_cache'];
			$thread_index = $_SESSION['gm_thread_index_cache'];
			//debug_print("used thread from cache".print_r($snapshot,true));
		} else {
			// retrieve from Gmail
			$gmailer->fetch($q);
			$snapshot = $gmailer->getSnapshot(GM_STANDARD|GM_LABEL|GM_QUERY|GM_CONVERSATION);
			if ($snapshot->created == 0) static_error($snapshot->snapshot_error);
			$_SESSION['gm_thread_cache'] = $snapshot;
			$_SESSION['gm_thread_cache_id'] = $th;
			$_SESSION['gm_thread_index_cache'] = array();
			if (!isset($snapshot->conv)) {
				if (!isset($snapshot->snapshot_error)) {
					//debug_print(basename(__FILE__).": ".__LINE__.", conv AND snapshot_error undefined?!?: ".print_r($snapshot,true));
					//debug_print(basename(__FILE__).": ".__LINE__.", conv AND snapshot_error undefined?!?: dumping gmail response: ".print_r($gmailer->debug_gmail_response(),true));
				}

				if (substr($snapshot->snapshot_error,0,1) == 5) {
					// http error
					//debug_print(basename(__FILE__).": ".__LINE__.", displayed Gmail server error: ".$snapshot->snapshot_error);
					static_error($snapshot->snapshot_error);
					
				} else {
					// msg not found, redirect to last mailbox
					//debug_print(basename(__FILE__).": ".__LINE__.", displayed message not found error: ".$snapshot->snapshot_error);
					msg_not_found($snapshot->snapshot_error);
				}

			} else {
				$count_conversations = count($snapshot->conv);
				for ($i = 0; $i < $count_conversations; $i++) {
					$id = $snapshot->conv[$i]['id'];
					$_SESSION['gm_thread_index_cache']["$id"] = $i;
				}
				$thread_index = $_SESSION['gm_thread_index_cache'];
			}
			//debug_print("thread not in cache, retrieved from gmail");
			//debug_print("indexed thread: ".print_r($_SESSION['gm_thread_index_cache'],true));
			//debug_print("retrieved thread: ".print_r($snapshot,true));
		}
	}
	//debug_print("current snapshot: ".print_r($snapshot,true));
} else {
	// retrieve from Gmail
	$gmailer->fetch($q);
	$snapshot = $gmailer->getSnapshot(GM_STANDARD|GM_LABEL|GM_QUERY|GM_CONVERSATION);
	if ($snapshot->created == 0) static_error($snapshot->snapshot_error);
	// if it's a mailbox, cache it for "act on selected msgs..."
	$_SESSION['gm_box_cache'] = (isset($snapshot->box)) ? $snapshot->box : "" ;
	//debug_print("retrieved data from gmail");
}
// for debugging
//debug_print("gmailer object: ".print_r($gmailer,true));
//debug_print("Snapshot: ".print_r($snapshot,true));
//debug_print("datapack raw: ".print_r($gmailer->dump_raw(),true));
//debug_print("gmail raw: ".print_r($gmailer->debug_gmail_response(),true));
//exit;


// if the requested thread/msg was not found, gracefully return to previous mailbox
if (!$snapshot->created) {
	// msg not found, redirect to last mailbox
	if (isset($snapshot->snapshot_error)) {
		msg_not_found($snapshot->snapshot_error);
	} else {
		//debug_print(basename(__FILE__).": ".__LINE__.", msg not found AND snapshot_error undefined ?!?!, dumping snapshot:\n".print_r($snapshot,true));
		//debug_print(basename(__FILE__).": ".__LINE__.", conv AND snapshot_error undefined?!?: dumping gmail response: ".print_r($gmailer->debug_gmail_response(),true));
	}
	
}
//
//////////////////////////

if (!isset($snapshot->quota_mb) or !isset($snapshot->quota_tot) or !isset($snapshot->quota_per)) {
	// redirect
	header("Location: http://".HOST.DIR_PATH."/index.php?err=20");
	// MUST exit script after redirecting
	exit;
} 

if (($sum and $conf['disp_total_msgs'])) {
	$gmailer->fetchBox(GM_PREFERENCE, 0, 0);
	$snapshot2 = $gmailer->getSnapshot(GM_PREFERENCE);
	if ($snapshot2->created == 0) static_error($snapshot2->snapshot_error);

}

// updates the current label list in cache
// used on subsequent accesses when performing a label action
if (!isset($_SESSION['gm_all_labels'])) {
	$_SESSION['gm_all_labels'] = $snapshot->label_list;
}

//////////////////////////
//
// mailbox view
//
if (!$sum and !$th) {

	if ($query) {
		$msgs_per_page = (floor($_SESSION['gm_msg_per_page']/2) < 5) ? 5 : floor($_SESSION['gm_msg_per_page']/2) ;
	} else {
		$msgs_per_page = $_SESSION['gm_msg_per_page'];
	}

	// if there are no messages in the box, go a page that has a message by making another query.
	if (count($snapshot->box) == 0 and $pos > 0) {
		$pos = ((ceil($snapshot->box_total/$msgs_per_page)-1) * $msgs_per_page);
		if ($pos < 0) $pos = 0;
		$_SESSION['gm_last_position'] = $pos;
		if ($_SESSION['gm_search_query'] == "is:unread") {
			// unread
			$q = "search=query&q=is%3Aunread&view=tl&start=".$pos;
		} elseif ($_SESSION['gm_last_box'] == "search") {
			// search results
			$q = "search=query&q=".urlencode($_SESSION['gm_search_query'])."&view=tl&start=".$pos;
		} elseif ($_SESSION['gm_last_box'] == "label") {
			// Label box
			$q = "search=cat&cat=".urlencode($_SESSION['gm_last_box_name'])."&view=tl&start=".$pos;
		} elseif ($_SESSION['gm_last_box'] == "std") {
			// Standard box
			$q = "search=".$_SESSION['gm_last_box_name']."&view=tl&start=".$pos;
		} else {
			$q = "search="."inbox"."&view=tl&start=".$pos;
		}
		$gmailer->fetch($q);
		$snapshot = $gmailer->getSnapshot(GM_STANDARD|GM_LABEL|GM_QUERY|GM_CONVERSATION);
		if ($snapshot->created == 0) static_error($snapshot->snapshot_error);
		// if it's a mailbox, cache it for "act on selected msgs..."
		$_SESSION['gm_box_cache'] = (isset($snapshot->box)) ? $snapshot->box : "" ;
	}

	print_headers();			// send wml headers
	include("template.php");	// print template

	$ids = "-1";
	$values = "-1";
	$set_vars = "";
	$count_the_box = count($snapshot->box);
	for ($i = 0; $i < $count_the_box && $i < $msgs_per_page; $i++) {
		$ids .= ";".$snapshot->box[$i]['id'];
		$values .= ";"."$(m_".$snapshot->box[$i]['id'].")";
		$set_vars .= "<setvar name=\"m_".$snapshot->box[$i]['id']."\" value=\"0\" />\n";
	}
	
	echo "<card title='".$title."'>\n";
	?>
	<onevent type="onenterforward">
	<refresh>
	<? echo $set_vars ; ?>
	</refresh>
	</onevent>
	<?

	echo "<p>\n";

	// display a system-wide message
	system_message();	
	
	//if (isset($status_message) and $status_message != "") echo "<b>".$status_message."</b><br /><br />\n";

	// for debugging
	//debug_print(print_r($snapshot,true));
	//debug_print(print_r($gmailer,true));

	if ($unread) {
		// a special search
		$box_name = $gm_lang['unread'];
	} elseif ($unlabeled) {
		// a special search
		$box_name = $gm_lang['unlabeled'];
	} else {
		// all other searches
		if ($pos == 0) {
			// display longer search query on first results page
			$search_query_length = 200;
		} else {
			// display shorter search query on other pages
			$search_query_length = 75;
		}
		if (strlen($snapshot->box_name) > $search_query_length) {
			// take a snippet of the search query
			$box_name = substr($snapshot->box_name,0,$search_query_length)." ...";
		} else {
			$box_name = $snapshot->box_name;
		}
	}

	echo "<b>".cleanse_string($box_name)."</b><br /><br />\n";

	// if this is a search, display a search lines
	if ($query) {
		if (isset($_GET['so']) and $_GET['so'] != "") {
			$so_flag = "so=1";
		} else {
			$so_flag = "";
		}
		echo "<a href='search.php?".$so_flag.GMID."'>".$gm_lang['srch_mail_again']."</a><br />\n";
		echo "---------------<br /><br />\n";
	}

	$num_msgs_printed = 0;
	
	$count_the_box = count($snapshot->box);
	for ($i = 0; $i < $count_the_box && $i<$msgs_per_page; $i++) {
		// display "star.gif" if the msg is starred
		if ($snapshot->box[$i]['is_starred']) {
			echo "<img src='star.gif' alt='*' /> ";
		} /* else { */
/* 			echo "<img src='nost.gif' alt='' /> "; */
/* 		} */

		// display "from"
		$sender = str_replace(array("<b>","</b>"),array("[[b]]","[[/b]]"), $snapshot->box[$i]['sender']);
		$sender = cleanse_string($sender);
		$sender = str_replace(array("[[b]]","[[/b]]"),array("<b>","</b>"), $sender);
		echo "$sender<br />\n";
		
		// display labels
		$all_msg_labels = "";
		foreach ($snapshot->box[$i]['labels'] as $label_entry) {
			switch ($label_entry) {
				case "^i": 	$label_entry_name = $gm_lang['std_box_name'][0]; break;
				case "^s": 	$label_entry_name = $gm_lang['std_box_name'][5]; break;
				case "^k": 	$label_entry_name = $gm_lang['std_box_name'][6]; break;
				case "^r": 	$label_entry_name = $gm_lang['std_box_name'][3]; break;
				default:	$label_entry_name = $label_entry; 				 break;
			}
			$all_msg_labels .= ($all_msg_labels != "") ? ", ".$label_entry_name : $label_entry_name ;
		}
		if ($all_msg_labels != "") echo "<small>".cleanse_string($all_msg_labels)."</small><br />\n";
		
		// display "to" flag
		$flag = false;
		if ($snapshot->box[$i]['flag'] == "<b>&rsaquo;</b>&nbsp;") {
			echo "&gt;&nbsp;";
			$flag = true;
		} elseif ($snapshot->box[$i]['flag'] == "<b>&raquo;</b>&nbsp;") {
			echo "&gt;&gt;&nbsp;";
			$flag = true;
		}

		// Subject: remove the <b> that gmail put on new mail
		$subject = str_replace(array("<b>","</b>"),"", $snapshot->box[$i]['subj']);
		$subject = html_entity_decode($subject);
		$subject = str_replace(array("$"),array(""),$subject);

		// cut the subject down to something more manageable for mobiles
		if (strlen($subject) > 60) {
			$subject = substr($subject,0,60)."...";
		}
		$subject = cleanse_string($subject,true);
		
		$subject = "<a href='main.php?th=".$snapshot->box[$i]['id'].GMID."'>$subject</a>";

		// Subject: if the message is unread, display it so
		if ($snapshot->box[$i]['is_read'] == 1) {
			if ($conf['unread_bold']) {
				// display unread messages in bold
				echo "<b>*&nbsp;$subject</b><br />\n";
			} else {
				// display unread messages with an asterix (*)
				echo "<b>*&nbsp;</b>$subject<br />\n";
			}
		} else {
			echo "$subject<br />\n";
		}

		// display date
		echo cleanse_string($snapshot->box[$i]['date'])."<br />\n";
		

		// display attachments if any
		$attach_count = count($snapshot->box[$i]['attachment']);
		if ($attach_count > 0) {
			echo "<img src='clip.gif' alt='@' />&nbsp;(".$attach_count.")<br />";
		}

		// if this is a search, display a snippet
		if ($query and trim($snapshot->box[$i]['snippet']) != "") {
			$query_snippet = str_replace(array("&hellip;"),array("..."), $snapshot->box[$i]['snippet']);
			$query_snippet = str_replace(array("$"),array("[dollar]"), $query_snippet);
			echo "<small>".$query_snippet."</small><br />\n";
		}	

		echo "<select name=\"m_".$snapshot->box[$i]['id']."\">\n";
		echo "<option value=\"0\"> - </option>\n";
		echo "<option value=\"1\">".$gm_lang['select']."</option>\n";
		echo "</select>\n";

		// need a break!
		echo "<br />\n";
		

		// increment number of messages printed
		$num_msgs_printed++;			   
	}
	echo "<br />\n";
	if ($pos >= 2 * $msgs_per_page) {
		echo "<a href='main.php?pos=0".RANDOM.GMID."'>&lt;&lt;&nbsp;".$gm_lang['newest']."</a><br />";
	}
	if ($pos >= $msgs_per_page) {
		$p = $pos - $msgs_per_page;
		echo "<a href='main.php?pos=".$p.RANDOM.GMID."'>&lt;&nbsp;".$gm_lang['newer']."</a><br />";
	}
	$start = $pos + 1;
	$end = $pos + $num_msgs_printed;
	if ($num_msgs_printed == 0) {
		echo sprintf($gm_lang['convs_printed'],$pos,$pos,$snapshot->box_total)."<br />"; 
	} else {
		echo sprintf($gm_lang['convs_printed'],$start,$end,$snapshot->box_total)."<br />"; 
	}
	if ($pos < $snapshot->box_total - $msgs_per_page) {
		$p = $pos + $msgs_per_page;
		echo "<a href='main.php?pos=".$p.RANDOM.GMID."'>".$gm_lang['older']."&nbsp;&gt;</a><br />\n";
		$very_last_page = ((ceil($snapshot->box_total/$msgs_per_page)-1) * $msgs_per_page);
		if ($very_last_page > $pos + $msgs_per_page) {
			echo "<a href='main.php?pos=".$very_last_page.RANDOM.GMID."'>".$gm_lang['oldest']."&nbsp;&gt;&gt;</a><br />\n";
		}
	}
	echo "<br />\n";

	if ($num_msgs_printed > 0) { ?>
	<anchor title="<? echo $gm_lang['act_on_sel_msg'] ?>"><go href="<? echo basename(SELF).'?mact=1&amp;'.strip_tags(SID) ?>" method="post">
		<?
		echo "<postfield name=\"m_ids\" value=\"".$ids."\" />\n";
		echo "<postfield name=\"m_vals\" value=\"".$values."\" />\n";
		?>
	</go><? echo $gm_lang['act_on_sel_msg'] ?></anchor>
	<br />
	<? }

	if ($_SESSION['gm_links_display'] != 2) {
		echo "---------------<br />\n";
		echo "<a href='compose.php?action=new".GMID."'>".$gm_lang['compose_mail']."</a><br />\n";
		echo "<a href='main.php?sum=1".GMID."'>".$gm_lang['summary']."</a><br />\n";
		echo "<a href='search.php?".GMID."'>".$gm_lang['search_mail']."</a><br />\n";
		echo "<a href='search.php?so=1".GMID."'>".$gm_lang['search_options']."</a><br />\n";
		echo "<a href='logout.php?".RANDOM.GMID."'>".$gm_lang['sign_out']."</a>\n";
	}
	echo "</p>\n";
	print_footer();
	exit;
//
// END: mailbox view
//
//////////////////////////


//////////////////////////
//
// Older msgs in thread
//
} elseif (!$sum and $th and $start_msg) {
	$th_content = "";

	// for debugging
	//debug_print(print_r($snapshot,true));
	// for debugging
	//debug_print(print_r($gmailer,true));

	$last_in_thread = $_SESSION['gm_thread_cache']->conv_total-1;
	$first_msg 		= $start_msg;
	$last_msg 		= $start_msg - (2*$dis_older_ths);
	
	for ($msg_index = $first_msg; $msg_index >= $last_msg; $msg_index--) {
		if (!isset($_SESSION['gm_thread_cache']->conv[$msg_index])) continue;

		$message = $_SESSION['gm_thread_cache']->conv[$msg_index];

		$snippet = trim(strip_tags($message['snippet']));
		if ($snippet == "") {
			// if snippet is empty, lets take from the body
			$body = trim(html_entity_decode(strip_tags($message['body'])));
			if ($body == "") {
				$snippet = $gm_lang['no_text'];
			} else {
				// take a snippet from the body
				if (strlen($body) > 60) {
					$snippet = trim(substr($body,0,60))."...";
				} else {
					$snippet = $body;
				}
			}
		}
		$snippet = cleanse_string($snippet,true);			

		if ($msg_index == $first_msg) {
			if (isset($_SESSION['gm_thread_cache']->conv[$msg_index+1])) {
				$thread_list_start = $msg_index+(2*$dis_older_ths);
				$th_content .= "<a href='main.php?th=".$th."&amp;mst=".$thread_list_start.GMID."'>&lt; ".$gm_lang['newer_msgs']."</a><br /><br />\n";   
			}
		}
		
		$msg_num = $msg_index+1;
		$th_content .= "-".$msg_num."- ".cleanse_string($message['sender'])."<br />\n";
		$th_content .= "<a href='main.php?th=".$th."&amp;mg=".$message['id'].GMID."'>".$snippet."</a><br />\n";


		if ($msg_index == $last_msg) {
			if (($msg_index-1 >=0) and (isset($_SESSION['gm_thread_cache']->conv[$msg_index-1]))) {
				$thread_list_start = $msg_index-1;
				$th_content .= "<br /><a href='main.php?th=".$th."&amp;mst=".$thread_list_start.GMID."'>".$gm_lang['older_msgs']." &gt;</a><br />\n";   
			}
		}
	}


	print_headers();			// send wml headers
	include("template.php");	// print template

	echo "<card title='".$gm_lang['msgs_in_conv']."' id='main'>\n";
	echo "<p>";
	// display a system-wide message
	system_message();	
	echo "<b>".$gm_lang['msgs_in_t_conv']."</b><br /><br />";
	echo $th_content;
	echo "<br />\n----------<br />\n";// divider ;-)
	echo "<a href='main.php?th=".$th.GMID."'>".$gm_lang['cur_msg_in_conv']."</a><br />\n";
	echo "</p>\n";
	echo "</card>\n";
	echo "</wml>";


	exit;
//
// END: Older msgs in thread
//
//////////////////////////


//////////////////////////
//
// Conversation view
//
} elseif (!$sum and $th) {

	print_headers();			// send wml headers
	include("template.php");	// print template

	echo "<card title='".$gm_lang['conversation']."' id='main'>\n";
	echo "<onevent type='onenterforward'>\n";
	echo "<refresh>\n";
	echo "<setvar name='act' value='0' />\n";
	echo "<setvar name='label' value='' />\n";
	echo "</refresh>\n";
	echo "</onevent>\n";
	
	echo "<p>";

	// display a system-wide message
	system_message();	

	if ($status_message != "") echo "<em>".$status_message."</em><br /><br />\n";
	echo "<b>".$gm_lang['subject']."</b> ".cleanse_string($snapshot->conv_title)."</p>\n";

	$old_content = "";
	$new_content = "";
	// for debugging
	//debug_print(print_r($snapshot,true));
	// for debugging
	//debug_print(print_r($gmailer,true));
	//debug_print(print_r($gmailer->dump_raw(),true));

	//$last_in_thread = ($_SESSION['gm_thread_cache']->conv_total)-1;
	$last_in_thread = (count($_SESSION['gm_thread_cache']->conv))-1;
	$main_msg 		= ($mg) ? $thread_index[$mg] : $last_in_thread;
	$first_msg 		= $main_msg + $dis_older_ths;
	$last_msg 		= $main_msg - $dis_older_ths;
	//$thread_id		= $_SESSION['gm_thread_cache_id'];

	for ($msg_index = $first_msg; $msg_index >= $last_msg and $msg_index >= 0; $msg_index--) {
		if (!isset($_SESSION['gm_thread_cache']->conv[$msg_index])) continue;

		// for debugging
		//debug_print(print_r($message,true));

		$msg_num = $msg_index+1;

		if ($msg_index == $first_msg) {
			if (isset($_SESSION['gm_thread_cache']->conv[$msg_index+1])) {
				$thread_list_start = $msg_index+1;
				$new_content .= "<br /><a href='main.php?th=".$th."&amp;mst=".$thread_list_start.GMID."'>&lt; More newer msgs</a><br /><br />\n";   
			}
		}	
	
		if ($msg_index != $main_msg) {
			$message = $_SESSION['gm_thread_cache']->conv[$msg_index];
			//debug_print("Not the requested msg: on index ".$msg_index);
			// if the message number is NOT the last in the conversation,
			// we are on an older msg and should display it on the "old
			// msgs in conv" list in reverse order (newer is first)
			$snippet = trim(strip_tags($message['snippet']));
			if ($snippet == "") {
				// if snippet is empty, lets take from the body
				$body = trim(html_entity_decode(strip_tags($message['body'])));
				if ($body == "") {
					$snippet = $gm_lang['no_text'];
				} else {
					// take a snippet from the body
					if (strlen($body) > 60) {
						$snippet = trim(substr($body,0,60))."...";
					} else {
						$snippet = $body;
					}
				}
			}
			$snippet = cleanse_string($snippet,true);			

			$temp_snip = "-".$msg_num."- ".(($message['is_draft']) ? "<b>DRAFT</b> " : "").cleanse_string($message['sender'])."<br />\n";
			$temp_snip .= "<a href='main.php?th=".$th."&amp;mg=".$message['id'].GMID."'>".$snippet."</a><br />\n";
/* 		$th_content .= "-".$msg_num."- ".cleanse_string($message['sender'])."<br />\n"; */
/* 		$th_content .= "<a href='main.php?th=".$th."&amp;mg=".$message['id'].GMID."'>".$snippet."</a><br />\n"; */

			if ($msg_index > $main_msg) {
				$new_content = $temp_snip . $new_content;
			} else {
				$old_content .= $temp_snip;  
			}
		}
		
	 	if ($msg_index == $last_msg) {
			if (($msg_index-1 >=0) and (isset($_SESSION['gm_thread_cache']->conv[$msg_index-1]))) {
				$thread_list_start = $msg_index-1;
				$old_content .= "<br /><a href='main.php?th=".$th."&amp;mst=".$thread_list_start.GMID."'>".$gm_lang['more_older_msgs']."&nbsp;&gt;</a>\n";   
			}
		}
				
		if ($msg_index == $main_msg) {
			if ($mg and !$msg_is_draft) {
				$message = $snapshot->conv[0];
			} else {
				$message = $_SESSION['gm_thread_cache']->conv[$msg_index];
			}
			$main_message = $message;
			
			//debug_print("displaying message current message in thread: ".print_r($message,true));

			echo "<p>\n";
			if ($message['is_draft']) {
				$all_receivers = "";
				echo "<b>".$gm_lang['from']."</b> ".$gm_lang['me']."<br />\n";
				$count_recv_email = count($message['recv_email']);
				for ($recv = 0; $recv < $count_recv_email; $recv++) {
					$all_receivers .= ($recv == 0) ? $message['recv_email'][$recv] : ", ".$message['recv_email'][$recv];
				}
				if (strlen($all_receivers) > 120) $all_receivers = substr($all_receivers,0,120)."...";
				if (	count($message['cc_email']) > 0
					or count($message['bcc_email']) > 0
					) {
					$all_receivers .= " ".$gm_lang['and_others'];
				}
				echo "<b>".$gm_lang['to']."</b> ".cleanse_string($all_receivers)."<br />\n";
			} else {
				//debug_print("message dump: ".print_r($message,true));
				if ($message['sender'] == $message['sender_email']) {
					echo "<b>".$gm_lang['from']."</b> ".cleanse_string($message['sender'])."<br />\n";
				} else {
					echo "<b>".$gm_lang['from']."</b> ".cleanse_string($message['sender'])." &lt;".cleanse_string($message['sender_email'])."&gt;<br />\n";
				}
				// Add to Contacts list button
				echo "<small><a href=\"main.php?astc=1&amp;th=".$th."&amp;mg=".$message['id'].GMID."\">".$gm_lang['add_sender_cnts']."</a></small><br />\n";
				$to_count = count($message['recv_email']);
				$cc_count = count($message['cc_email']);
				$recip_count = $to_count + $cc_count;
				$recips = "";
				for($to_recip = 0; $to_recip < 5; $to_recip++) {
					if (isset($message['recv_email'][$to_recip])) {
						$recips .= ($recips != "") ? ", ".$message['recv_email'][$to_recip] : $message['recv_email'][$to_recip] ;
					}
				}
				if (($to_count > 5) or ($cc_count > 0)) {
					$recip_count = "(".$recip_count.") ";
					$recips .= " ".$gm_lang['and_others'];
				} else {
					$recip_count = "";
				}
				echo "<b>".$gm_lang['to']."</b> ".$recip_count.cleanse_string($recips)."<br />\n";
			}
			//we convert the special characters that google uses to display the time
			echo "<b>".$gm_lang['date']."</b> ".cleanse_string(str_replace(array("&frac14;","&frac12;","&frac34;"),array("-1/4","-1/2","-3/4"),$message['dt_easy']))."<br />\n";

			// show labels
			$all_conv_labels = "";
			if (!isset($snapshot->conv_labels)) {
				//debug_print("conv_labels not set: dump: ".print_r($snapshot,true));
			} elseif (!is_array($snapshot->conv_labels)) {
				//debug_print("conv_labels not an array: dump: ".print_r($snapshot,true));
			} elseif (count($snapshot->conv_labels) > 0) {
			//if (count($snapshot->conv_labels) > 0) {
				foreach ($snapshot->conv_labels as $indexval => $this_label) {
					switch ($this_label) {
						case "^i": 	$label_entry_name = $gm_lang['std_box_name'][0]; break;
						case "^s": 	$label_entry_name = $gm_lang['std_box_name'][5]; break;
						case "^k": 	$label_entry_name = $gm_lang['std_box_name'][6]; break;
						case "^r": 	$label_entry_name = $gm_lang['std_box_name'][3]; break;
						default:	$label_entry_name = $this_label; 				 break;
					}

					if ($all_conv_labels == "") $all_conv_labels = $label_entry_name;
					else $all_conv_labels .= ", ".$label_entry_name;
				}
				if ($all_conv_labels == "") $all_conv_labels = $gm_lang['none_paren'];
				// remove "blank" labels (gmail doesn't display the label of a standard
				// box if you are IN that box)
				$all_conv_labels = trim(str_replace(", ,",",",$all_conv_labels));
				echo "<b>".$gm_lang['labels_col']."</b> ".cleanse_string($all_conv_labels)."<br />\n";
			}

			// show number of attachments
			$num_attach = count($message['attachment']);
			$img_attach = "";
			if (eregi('/mail/\?.*attid=([^&]*)&amp;th=', $message['body'])) {
				$num_attach++;
				$img_attach = "+";
			}

			if ($num_attach > 0 ) {
				$attachments = ($num_attach == 1) ? $num_attach.$img_attach." ".$gm_lang['attachment'] : $num_attach.$img_attach." ".$gm_lang['attachments'] ;
				$attachments = "<a href=\"attach.php?th=$th&amp;mg=".$message['id'].GMID."\">$attachments</a>";
				echo $attachments."<br />\n";
			}
			
			// display star if starred
			if ($message['is_star']) {
				echo "<img src='star.gif' alt='*' /><br />\n";
			}
/* 			if ($message['is_star']) { */
/* 				echo "<a href=\"main.php?st=0".GMID."\"><img src='star.gif' alt='*' /></a><br />\n"; */
/* 			} else { */
/* 				echo "<a href=\"main.php?st=1".GMID."\"><img src='nost.gif' alt='' /></a><br />\n"; */
/* 			} */


			// divider ;-)
			echo "</p><p align=\"center\">----------";
			if ($message['is_draft']) echo "<br /><b>".$gm_lang['draft_all_caps']."</b>";

			// phishing warning
			$phishing_warn = "";
			if ($message['warning'] != "") {
				$phishing_warn = str_replace($gm_lang['learn_more'],"",sanitize_body($message['warning']));
				echo "<br /><b>".$phishing_warn."</b>\n";
				echo "----------";
			}
			
			// end divider ;-)
			echo "</p>\n";

			// get the message text
			$body = $message['body'];

			//debug_print("message body: ".print_r($body,true));
			
			// a hack to fix previous improperly forwarded messages from gmail-mobile
			$reg_exp = "<br />(<span class=.*>)?(.*)&lt;span id=&quot;_user_.+<.+>.*</a>&quot;&gt;.*&lt;/span&gt;.* &lt;.+&lt;<.+>(.*)</a>&gt;&gt;<br /><br />(</span>)?";
			//$body = ereg_replace($reg_exp,"<br />\\2\\3<br /><br />",$body);

			// clean the message text, and removes unnecessary html tags like <div> and javascript
			if (strlen($body) > 76800) {
				// message is just obnoxiously large for any practical value on a mobile
				$body = $gm_lang['msg_too_long_to_display'];
			} elseif ($message['is_draft']) {
				$body = cleanse_string($body);
			} else {
				$body = sanitize_body($body);
				// prepare show/hide quoted text
				if ($quoted_show) {
					// show the quoted part of the message text
					// add button to hide the text
					$body = str_replace($gm_lang['show_quote_text'],
						"<br />\n<a href=\"".basename(SELF)."?th=$th&amp;mg=".$message['id'].GMID."\">".
						$gm_lang['hide_quote_text']."</a><br />\n",
						$body);
				} else {
					// hide the quoted part of the message text
					$quote_pos = strpos($body, $gm_lang['show_quote_text']);
					if (!($quote_pos === false)) {
						// keep everything UNTIL the quoted part
						$body = trim(substr($body,0,"$quote_pos"));
						// if the text is empty say so
						if ($body == "") $body = $gm_lang['no_try_show']."<br />\n";
						// add the button to show the text
						$body .= "<br />\n<a href=\"".basename(SELF)."?quote_show=1&amp;th=$th&amp;mg=".$message['id'].GMID."\">".$gm_lang['show_quote_text']."</a><br />\n";
					}

				}
			}

			$body_dis_length = ($phishing_warn != "") 
				? $_SESSION['gm_msg_dis_length'] - strlen($phishing_warn)
				: $_SESSION['gm_msg_dis_length']
				;
			
			if ($body == "") $body = $gm_lang['no_text'];
			if (strlen($body) > $body_dis_length) {
				// breaking messages into parts
				$msg_parts = ceil(strlen($body)/$body_dis_length);
				$msg_start = ($body_dis_length * ($msg_part-1));
				$previous = $msg_part-1;
				$next = $msg_part+1;

				// display part number
				echo "<p>\n";
				echo "<b>".sprintf($gm_lang['showing_part'],$msg_part,$msg_parts)." </b><br />\n";
				if ($msg_part > 1) {
					if ($msg_part > 1) echo "<a href=\"main.php?th=$th&amp;mg=".$message['id']."&amp;msg_part=$previous".(($quoted_show) ? "&amp;quote_show=$quoted_show" : "").GMID."\">".$gm_lang['prev']."</a>";
					if (($msg_part > 1) and ($msg_part < $msg_parts)) echo " | ";
					if ($msg_part < $msg_parts) echo "<a href=\"main.php?th=$th&amp;mg=".$message['id']."&amp;msg_part=$next".(($quoted_show) ? "&amp;quote_show=$quoted_show" :"").GMID."\">".$gm_lang['next']."</a>\n";
					echo "<br />\n";
				}
				echo "<br />\n";
	
				// cuts the message to part size
				$body = substr($body,$msg_start,$body_dis_length);
				// cleans the part of broken <br /> tags
				$body = preg_replace('/^(b*?r*?\s*?\/*?\>)|(<b*?r*?\s*?\/*?)$/is', '', $body); 
				// cleans the part of broken &amp; &gt; and &lt; tags
				$body = preg_replace('/(\&g*?t*?)$|(\&l*?t*?)$|(\&a*?m*?p*?)$|(\&\#*?3*?9*?)$|(\&\#*?3*?4*?)$|(\&q*?u*?o*?t*?)$/is', '', $body); 
				// display the message text
				echo $body."<br />\n";
				echo "\n";

				// next and previous part buttons
				echo "<br />\n";
				echo "<b>".sprintf($gm_lang['showing_part'],$msg_part,$msg_parts)." </b><br />\n";
				if ($msg_part > 1) echo "<a href=\"main.php?th=$th&amp;mg=".$message['id']."&amp;msg_part=$previous".(($quoted_show) ? "&amp;quote_show=$quoted_show" :"").GMID."\">".$gm_lang['prev']."</a>";
				if (($msg_part > 1) and ($msg_part < $msg_parts)) echo " | ";
				if ($msg_part < $msg_parts) echo "<a href=\"main.php?th=$th&amp;mg=".$message['id']."&amp;msg_part=$next".(($quoted_show) ? "&amp;quote_show=$quoted_show" :"").GMID."\">".$gm_lang['next']."</a>\n";
				echo "<br />\n";
				echo "</p>\n";   
			} else {
				// only one "part"... display it
				echo "<p>".$body."</p>\n";
			}
			echo "<p align=\"center\">\n";
			echo "<br />\n";
			echo "---------------<br /></p>\n";
		}
	}
	
	// encode $back for use when composing
	$_SESSION['gm_back'] = code_url('main.php?th='.$snapshot->conv_id,"encode");
	echo "<p>\n";

	$current_message = ($mg) ? $mg : $th ;
	
	$message = $main_message;

	// reply/resume and forward buttons
	if ($message['is_draft']) {
		$parent = $message['draft_parent'];
		echo "<a href='compose.php?draft=1&amp;th=".$snapshot->conv_id."&amp;mg=".$parent.GMID."'>".$gm_lang['resume']."</a><br />\n";
	} else {
		echo "<a href='compose.php?action=reply1&amp;th=".$snapshot->conv_id."&amp;mg=".(($mg) ? $mg : $th).GMID."'>".$gm_lang['reply_options']."</a><br />\n";
/* 		echo "<a href='compose.php?fwd=1&amp;th=".$snapshot->conv_id."&amp;mg=".(($mg) ? $mg : $th).GMID."'>".((count($message['attachment']) > 0 ) ? $gm_lang['forward_wo_attach'] : $gm_lang['forward'])."</a><br />\n"; */
		echo "<a href='compose.php?fwd=1&amp;th=".$snapshot->conv_id."&amp;mg=".(($mg) ? $mg : $th).GMID."'>".$gm_lang['forward']."</a><br />\n";
	}

	// old/new msgs in conv button, if there are any
	if (strlen($new_content) != 0) echo "<a href='#new'>".$gm_lang['new_msgs_inconv']."</a><br />\n";
	if (strlen($old_content) != 0) echo "<a href='#old'>".$gm_lang['old_msgs_inconv']."</a><br />\n";

	// done button
	echo "<a href=\"main.php?".GMID."\">&lt;&lt;&nbsp;".sprintf($gm_lang['back_to'],$_SESSION['gm_backto'])."</a><br /><br />\n";

	// search button
	echo "<a href='search.php?".GMID."'>".$gm_lang['search_mail']."</a><br /><br />\n";
	echo "<a href='search.php?so=1".GMID."'>".$gm_lang['search_options']."</a><br /><br />\n";

	//////////////////////////
	//
	// message action menu
	//
	echo $gm_lang['more_actions']."<br />";
	echo "<select name=\"act\" value=\"0\">\n";
	echo "<option value=\"0\">-".$gm_lang['select_action']."-</option>\n";

	// ^i is Inbox
	// ^s is Spam
	if (array_search("^s",$snapshot->conv_labels) !== false) {
		//echo "<option value=\"".GM_ACT_DELSPAM."\">".$gm_lang['delete_spam']."</option>\n";
		echo "<option value=\"".GM_ACT_UNSPAM."\">".$gm_lang['not_spam']."</option>\n";
	} elseif (array_search("^i",$snapshot->conv_labels) === false) {
		echo "<option value=\"".GM_ACT_INBOX."\">".$gm_lang['unarchive']."</option>\n";
	} else {
		echo "<option value=\"".GM_ACT_ARCHIVE."\">".$gm_lang['archive']."</option>\n";
	}

	echo "<option value=\"".GM_ACT_UNREAD."\">".$gm_lang['mark_unread']."</option>\n";

	if ($message['is_star']) {
		echo "<option value=\"".GM_ACT_UNSTAR."\">".$gm_lang['remove_star']."</option>\n";
	} else {
		echo "<option value=\"".GM_ACT_STAR."\">".$gm_lang['star']."</option>\n";
	}

	//echo "<option value=\"".GM_ACT_APPLYLABEL."\">Apply Label: </option>\n";
	//echo "<option value=\"".GM_ACT_REMOVELABEL."\">Remove Label: </option>\n";
	//echo "<option value=\"".GM_ACT_READ."\">".$gm_lang['mark_read']."</option>\n";

	if (!$message['is_draft']) {
		// ^s is Spam
		if (array_search("^s",$snapshot->conv_labels) === false) {
			echo "<option value=\"".GM_ACT_SPAM."\">".$gm_lang['report_spam']."</option>\n";
		}
	}

	// ^t is Draft
	if ($message['is_draft']) {
		echo "<option value=\"".GM_ACT_UNDRAFT."\">".$gm_lang['discard_draft']."</option>\n";
	// ^k is Trash
	} elseif (array_search("^k",$snapshot->conv_labels) !== false) {
		echo "<option value=\"".GM_ACT_UNTRASH."\">".$gm_lang['untrash_conv']."</option>\n";
		echo "<option value=\"".GM_ACT_DELTRASHED."\">".$gm_lang['del_forever']."</option>\n";
	} elseif (array_search("^s",$snapshot->conv_labels) !== false) {
		echo "<option value=\"".GM_ACT_DELSPAM."\">".$gm_lang['del_forever']."</option>\n";
	} else {
		echo "<option value=\"".GM_ACT_TRASHMSG."\">".$gm_lang['trash_msg']."</option>\n";
		echo "<option value=\"".GM_ACT_TRASH."\">".$gm_lang['trash_conv']."</option>\n";
		echo "<option value=\"".GM_ACT_DELFOREVER."\">! ".$gm_lang['del_perm']." !</option>\n";
	}
	echo "</select><br />\n";
	//
	//////////////////////////
	
	echo "<b>".$gm_lang['or']."</b><br />\n";

	//////////////////////////
	//
	// label menu
	//
	echo $gm_lang['app_rem_label']."\n";
	echo "<small>\n";
	echo $gm_lang['multiple_at_once'];
	echo "<anchor>".$gm_lang['reset']."<refresh>\n";
	echo "<setvar name=\"label\" value=\"\" />\n";
	echo "</refresh></anchor>\n";
	echo "</small><br />\n";
	$remove_label = "";
	$apply_label = "";
	foreach ($snapshot->label_list as $indexval => $label_name) {
		if (array_search($label_name,$snapshot->conv_labels) !== false) {
			$remove_label .= "<option value=\"-".$indexval."\">-".cleanse_string($label_name)."</option>\n";
		} else {
			$apply_label .= "<option value=\"".$indexval."\">+".cleanse_string($label_name)."</option>\n";
		}
	}

	if (count($snapshot->label_list) > 0) {
		echo '<select title="'.$gm_lang['labels_col'].'" name="label" multiple="true">'."\n";
		if ($apply_label != "") {
			echo "<optgroup title=\"".$gm_lang['apply_label']."\">\n";
			echo $apply_label;
			echo "</optgroup>\n";
		}
		if ($remove_label != "") {
			echo "<optgroup title=\"".$gm_lang['remove_label']."\">\n";
			echo $remove_label;
			echo "</optgroup>\n";
		}
		echo "</select>\n";
	} else {
		echo $gm_lang['have_no_labels']."<br />\n";
		echo "<small><a href='label.php?".GMID."#create'>".$gm_lang['create_a_label']."</a></small><br />\n";
	}

	//
	//////////////////////////


	//////////////////////////
	// 
	// Post action
	//
	echo "<big><b><anchor>".$gm_lang['go']."<go href=\"main.php?".strip_tags(SID)."\" method=\"post\">\n";
	echo "<postfield name=\"act\" value=\"$(act)\" />\n";
	echo "<postfield name=\"msgs\" value=\"$th\" />\n";
	echo "<postfield name=\"lbl\" value=\"$(label)\" />\n";
	echo "</go></anchor></b></big>\n";
	//
	//////////////////////////

	echo "</p>\n";
	echo "</card>\n";

	//////////////////////////
	//
	// list older msgs in the conversation, if any
	//
	if ($old_content != "") { 
		echo "<card title='".$gm_lang['older_messages']."' id='old'>\n";
		echo "<p>";
		// display a system-wide message
		system_message();	
		echo "<b>".$gm_lang['old_msgs_inconv_cap']."</b><br />";
		echo $old_content;
		//echo "<p>\n";
		echo "<br />\n----------<br />\n";		// divider ;-)
		echo "<a href='#main'>".$gm_lang['cur_msg_in_conv']."</a>\n";
		echo "</p>\n";
		echo "</card>\n";
	}
	//
	//////////////////////////

	//////////////////////////
	//
	// list newer msgs in the conversation, if any
	//
	if ($new_content != "") { 
		echo "<card title='".$gm_lang['newer_messages']."' id='new'>\n";
		echo "<p>";
		// display a system-wide message
		system_message();	
		echo "<b>".$gm_lang['new_msgs_inconv_cap']."</b><br />";
		echo $new_content;
		//echo "<p>\n";
		echo "<br />\n----------<br />\n";		// divider ;-)
		echo "<a href='#main'>".$gm_lang['cur_msg_in_conv']."</a>\n";
		echo "</p>\n";
		echo "</card>\n";
	}
	//
	//////////////////////////

	//print_footer();
	echo "</wml>";
	exit;

//
// END: Conversation view
//
//////////////////////////


//////////////////////////
//
// Summmary view
//
} else { 

	print_headers();			// send wml headers
	include("template.php");	// print template
	
	if (/* $_SESSION['gm_welcome_msg'] != "" or  */$clear_history) {
		echo "<card ontimer=\"main.php?".strip_tags(SID)."\" title='".$title."' newcontext='true'>\n";
	} else {
		echo "<card ontimer=\"main.php?".strip_tags(SID)."\" title='".$title."'>\n";
	}

	echo "<timer value=\"3000\" />\n";
	echo "<p>\n";
	// display a system-wide message
	system_message();	

	if ($_SESSION['gm_setting_gen_cache']['vacation_enabled']) {
		echo $gm_lang['vacation_on']." ".cleanse_string($_SESSION['gm_setting_gen_cache']['vacation_subject'])."<br />\n";
		echo "<small><a href='general.php?".GMID."'>".$gm_lang['vacation_settings']."</a><br /><br /></small>\n";
	}

	if ($_SESSION['gm_welcome_msg'] != "") {
		echo $_SESSION['gm_welcome_msg'];
		$_SESSION['gm_welcome_msg'] = "";
	} ?>
<b><? echo $title ?></b><br /><br />
<? if ($_SESSION['gm_links_display'] != 2) { ?>
<small>
	<a href='search.php?<? echo GMID ?>'><? echo $gm_lang['search_mail'] ?></a><br />
	<a href='search.php?so=1<? echo GMID ?>'><? echo $gm_lang['search_options'] ?></a><br />
</small>
	<br />
<? } 

$display_standard = false;
$print_standard = "<b>".$gm_lang['standard_boxes']."</b><br />\n";

$count_stdbox = count($stdbox);
for ($i = 0; $i < $count_stdbox; $i++) {
	if (array_search(strtolower($stdbox[$i]), $_SESSION['gm_display_boxes']) === false) continue;
	$display_standard = true;
	if ($conf['disp_total_standard']) {
		$gmailer->fetchBox(GM_STANDARD, strtolower($stdbox[$i]), 0);
		$snapshot_standard = $gmailer->getSnapshot(GM_STANDARD);
		$total = " (".$snapshot->std_box_new[$i]."/".$snapshot_standard->box_total.")";
	} else {
		if ($snapshot->std_box_new[$i] > 0) {
			$total = " (".$snapshot->std_box_new[$i].")";
		} else {
			$total = "";
		}
	}
	$print_standard .= "<a href='main.php?std=".strtolower($stdbox[$i]).GMID."'>".$gm_lang['std_box_name'][$i].$total."</a><br />\n";
} 

if ($display_standard) echo $print_standard;

if ($conf['disp_total_standard']) {
	$gmailer->fetch('search=query&q=is%3Aunread&view=tl&start=0');
	$snapshot_standard = $gmailer->getSnapshot(GM_STANDARD|GM_LABEL|GM_QUERY|GM_CONVERSATION);
	$total = " (".$snapshot_standard->box_total.")";
} else {
	$total = "";
}

$label_count = count($snapshot->label_list);
?>
<br />
<b><? echo $gm_lang['quick_search'] ?></b><br />
<a href="main.php?unread=1<? echo GMID ?>"><? echo $gm_lang['unread'].$total ?></a><br />
<? if ($label_count > 0) { ?>
<a href="main.php?unlab=1<? echo GMID ?>">Unlabeled</a><br />
<? } ?>
<br />
<?

$display_labels = false;
$print_labels = "<br /><b>".$gm_lang['labels']."</b><br />\n";

if ($label_count == 0) {
	$print_labels .= $gm_lang['have_no_labels']."<br />\n";
	$print_labels .= "<small><a href='label.php?".GMID."#create'>".$gm_lang['create_a_label']."</a></small><br />\n";
	$display_labels = true;
/* } elseif (!$_SESSION['gm_show_labels'] and $_SESSION['gm_display_boxes'] > 27){ */
/* 	echo "$label_count labels<br />\n"; */
/* 	echo "<small><a href='".basename(SELF)."?showlabels=1&amp;sum=1".GMID."'>".$gm_lang['show_all_labels']."</a></small><br />\n"; */
} else {
	for ($i = 0; $i < $label_count; $i++) {
		if (array_search($snapshot->label_list[$i], $_SESSION['gm_display_boxes']) === false) continue;
		$display_labels = true;
		if ($conf['disp_total_msgs']) {
			$total = " (".$snapshot->label_new[$i]."/".$snapshot2->label_total[$i].")";
		} else {
			if ($snapshot->label_new[$i] > 0) {
				$total = " (".$snapshot->label_new[$i].")";
			} else {
				$total = "";
			}
		}
		$print_labels .= "<a href='main.php?label=".$i.GMID."'>".cleanse_string($snapshot->label_list[$i]).$total."</a><br />\n";
	}
	if (!$display_labels) {
		$print_labels .= "<small>No labels chosen.  Use &quot;".$gm_lang['custom_summary_page']."&quot;"."</small><br />\n";
	}
}

/* if ($display_labels)  */echo $print_labels;
?>

</p>
<p>
<br />
<a href='mobile.php?<? echo GMID ?>'><? echo $gm_lang['custom_summary_page'] ?></a><br />
<?
echo "---------------<br />\n";
if ($_SESSION['gm_links_display'] != 2) { ?>
<a href='compose.php?action=new<? echo GMID ?>'><? echo $gm_lang['compose_mail']?></a><br />
<a href='contact.php?v=1&amp;p=0<? echo GMID ?>'><? echo $gm_lang['contacts'] ?></a><br />
<a href='search.php?<? echo GMID ?>'><? echo $gm_lang['search_mail'] ?></a><br />
<a href='search.php?so=1<? echo GMID ?>'><? echo $gm_lang['search_options'] ?></a><br />
<a href='setting.php?<? echo GMID ?>'><? echo $gm_lang['settings'] ?></a><br />
<? 
}
if ($snapshot->have_invit > 0) {
/* 	$friends = ($snapshot->have_invit == 1)  */
/* 		? sprintf($gm_lang['invite_friend'],$snapshot->have_invit)  */
/* 		: sprintf($gm_lang['invite_friends'],$snapshot->have_invit)  */
/* 		; */
/* 	echo "<a href=\"invite.php?".GNID."\">".$friends."</a><br />\n";  */
	echo "<a href=\"invite.php?".GMID."\">".sprintf($gm_lang['invite_friends'],$snapshot->have_invit)."</a><br />\n"; 
}
?>
<a href='logout.php?<? echo RANDOM.GMID ?>'><? echo $gm_lang['sign_out'] ?></a><br />
<br />
<small><? 
echo sprintf($gm_lang['quota_used'],$snapshot->quota_mb,$snapshot->quota_tot,$snapshot->quota_per); 
?></small>
</p>
<?
	print_footer();
	exit;
}


function clear_message_cache() {
	$_SESSION['gm_msg_cache_id']	= "";
	$_SESSION['gm_thread_cache_id']	= "";
/* 	$_SESSION['gm_thread_cache']	= (object)array(); */
/* 	$_SESSION['gm_msg_cache']		= (object)array(); */
	$_SESSION['gm_thread_index_cache']	= array();

}
?>