<?
/****************************************************************

gmail-mobile (a.k.a. unofficial Gmail Mobile)
Copyright (c) 2005, 2006
Neerav Modi and others

Version 0.11 (c) 2004
GAN Ying Hung, Rudi Pittman, Gaston Annebicque

Licensed under the GNU GPL. For full terms see the file COPYING.

gmail-mobile (unofficial Gmail Mobile since Sept 2004) provides
access to Gmail accounts with any WAP enabled phone or hand held
(in WML format).

http://gmail-mobile.sourceforge.net

*****************************************************************/

require_once("libgmailer.php");
require_once("config.php");

// create the gmail object
$gmailer = new GMailer();
// initialize connection
quick_init($gmailer);

// Connect to gmail
connect_gmail();

// Localization (l10n) phrases
load_language();
																																						 
$status = false;
$status_message = "";
$stdbox = GMailer::getStandardBox();

if (isset($_GET['act']) and $_GET['act'] == "save") {

	$mobile_display = array();

	if (isset($_POST['display'])) {
		$temp_display = explode(";",str_replace(")","",$_POST['display']));
	
		$count_posted = count($temp_display);
		for ($i=0 ; $i < $count_posted; $i++) {
			if (
				$temp_display[$i] == ""
					or
				$temp_display[$i] == -1				
			) {
				continue;
			}
			$index = substr($temp_display[$i],0,1);
			if ($index == "s") {
				$index = substr($temp_display[$i],1,1);
				if (isset($stdbox[$index])) $mobile_display[] = strtolower($stdbox[$index]);
			} else {
				if (isset($_SESSION['gm_all_labels'][$temp_display[$i]])) $mobile_display[] = $_SESSION['gm_all_labels'][$temp_display[$i]];
			}
		}
	}

	if (count($mobile_display) == 0) {
		$mobile_display = array("inbox");
	}

/* 	// perform the action */
/* 	$status = $gmailer->setSetting( */
/* 			$_SESSION['gm_setting_gen_cache']['language'], */
/* 			$_SESSION['gm_setting_gen_cache']['page_size'], */
/* 			$_SESSION['gm_setting_gen_cache']['shortcuts'], */
/* 			$_SESSION['gm_setting_gen_cache']['p_indicator'], */
/* 			$_SESSION['gm_setting_gen_cache']['show_snippets'], */
/* 			$_SESSION['gm_setting_gen_cache']['use_signature'], */
/* 			$_SESSION['gm_setting_gen_cache']['signature'], */
/* 			$_SESSION['gm_setting_gen_cache']['encoding'], */
/* 			$_SESSION['gm_setting_fpop_cache']['forward'], */
/* 			$_SESSION['gm_setting_fpop_cache']['forward_to'], */
/* 			$_SESSION['gm_setting_fpop_cache']['forward_action'], */
/* 			$_SESSION['gm_setting_fpop_cache']['pop_enabled'], */
/* 			$_SESSION['gm_setting_fpop_cache']['pop_action'], */
/* 			$_SESSION['gm_setting_other_cache']['rich_text'], */
/* 			$_SESSION['gm_setting_other_cache']['expand_labels'], */
/* 			$_SESSION['gm_setting_other_cache']['expand_invites'], */
/* 			$_SESSION['gm_setting_gen_cache']['vacation_enabled'], */
/* 			$_SESSION['gm_setting_gen_cache']['vacation_subject'], */
/* 			$_SESSION['gm_setting_gen_cache']['vacation_message'], */
/* 			$_SESSION['gm_setting_gen_cache']['vacation_contact'], */
/* 			$mobile_display */
/* 	); */

	// perform the action
	$status = $gmailer->setMobileSetting($mobile_display);

	// no status message is returned
	//$status_message	= $gmailer->lastActionStatus('message');

	if ($status) {
		$status_message	= $gm_lang['gm_prefs_saved'];
		$gmailer->fetchBox(GM_PREFERENCE, 0, 0);
		$snapshot = $gmailer->getSnapshot(GM_PREFERENCE);
		if ($snapshot->created == 0) static_error($snapshot->snapshot_error);
		$_SESSION['gm_setting_mobile_cache'] = $snapshot->setting_mobile;
		$_SESSION['gm_setting_gen_cache'] = $snapshot->setting_gen;
		$_SESSION['gm_setting_fpop_cache'] = $snapshot->setting_fpop;
		$_SESSION['gm_setting_other_cache'] = $snapshot->setting_other;
		$_SESSION['gm_all_labels'] = $snapshot->label_list;
		
		$_SESSION['gm_display_boxes'] = $_SESSION['gm_setting_mobile_cache']['display_boxes'];

		// actual redirection
		redirect_page("main.php?sum=1", $gm_lang['gmail_mobile_settings'], $status_message);	
		exit;
	} else {
		$status_message	= $gm_lang['gm_prefs_error'];
	}
	
} 

$gmailer->fetchBox(GM_PREFERENCE, 0, 0);
$snapshot = $gmailer->getSnapshot(GM_PREFERENCE);
if ($snapshot->created == 0) static_error($snapshot->snapshot_error);
$_SESSION['gm_setting_mobile_cache'] = $snapshot->setting_mobile;
$_SESSION['gm_setting_gen_cache'] = $snapshot->setting_gen;
$_SESSION['gm_setting_fpop_cache'] = $snapshot->setting_fpop;
$_SESSION['gm_setting_other_cache'] = $snapshot->setting_other;
$_SESSION['gm_all_labels'] = $snapshot->label_list;

$dis_mobile = $_SESSION['gm_setting_mobile_cache']['display_boxes'];
$_SESSION['gm_display_boxes'] = $_SESSION['gm_setting_mobile_cache']['display_boxes'];

$display = "-1";
$count_stdbox = count($stdbox);
for ($i = 0; $i < $count_stdbox; $i++) {
	if (array_search(strtolower($stdbox[$i]), $dis_mobile) !== false) {
		$display .= ';s'.$i;
	}
} 
reset($_SESSION['gm_all_labels']);
foreach ($_SESSION['gm_all_labels'] as $indexval => $label_name) {
	if (array_search($label_name, $dis_mobile) !== false) {
		$display .= ';'.$indexval;
	};
}

// for debugging
/* debug_print("gmailer object: ".print_r($gmailer,true)); */
//debug_print("snapshot: ".print_r($snapshot,true));
/* exit; */

	
print_headers();	// send wml headers
include("template.php");	// print template
	?>
<card title="<? echo $gm_lang['gmail_mobile'] ?>" id='main'>
<onevent type="onenterforward">
<refresh>
<setvar name="display" value="<? echo $display ?>" />
</refresh>
</onevent>
<p>
<?
// display a system-wide message
system_message();	

if ($status_message != "") echo "<em>".$status_message."</em><br /><br />\n";
?>
<b><? echo $gm_lang['gmail_mobile_settings'] ?></b><br />
<br />
<b><? echo $gm_lang['custom_summary'] ?></b><br />
<small><? echo $gm_lang['custom_summary_exp'] ?></small><br />
<? /*<small>
	<anchor><? echo $gm_lang['reset'] ? ><refresh>
		<setvar name="display" value="<? echo $display ? >" />
	</refresh></anchor>
</small><br />
*/
?>
<select title="<? echo $gm_lang['custom_summary'] ?>" name="display" multiple="true">

<optgroup title="<? echo $gm_lang['standard_boxes'] ?>">
<? 
for ($i = 0; $i < $count_stdbox; $i++) {
	echo "\t\t<option value=\"s".$i."\">".$stdbox[$i]."</option>\n";
} 
?>
</optgroup>
<? if (count($_SESSION['gm_all_labels']) > 0) { ?>
<optgroup title="<? echo $gm_lang['labels'] ?>">
	<?
	reset($_SESSION['gm_all_labels']);
	foreach ($_SESSION['gm_all_labels'] as $indexval => $label_name) {
		echo "\t\t<option value=\"".$indexval."\">".cleanse_string($label_name)."</option>\n";
	}
	?>
</optgroup>
</select><br />
<br />
<? } else { ?>
</select><br />
<br />
<small>
<? echo $gm_lang['have_no_labels'] ?>
</small><br />
<? } ?>

<? echo "<a href='setting.php?".RANDOM.GMID."'>".$gm_lang['cancel']."</a><br />\n"; ?>
<anchor title="<? echo $gm_lang['save_changes'] ?>"><go href="<? echo basename(SELF).'?act=save&amp;'.strip_tags(SID) ?>" method="post">
	<postfield name="display" value="$(display)" />
</go><? echo $gm_lang['save_changes'] ?></anchor>
<br />
<?
if ($_SESSION['gm_links_display'] != 2) {
	echo "--------<br />";
	echo "<a href='setting.php?".RANDOM.GMID."'>".$gm_lang['settings']."</a><br />\n";
	echo "<a href='main.php?sum=1".RANDOM.GMID."'>".$gm_lang['summary']."</a><br />\n";
	echo "<a href='compose.php?action=new&amp;back=".basename(SELF).RANDOM.GMID."'>".$gm_lang['compose_mail']."</a><br />\n";
	echo "<a href='logout.php?".RANDOM.GMID."'>".$gm_lang['sign_out']."</a>\n";
}
echo "</p>\n";

print_footer();

?>